
package converter;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Stroke;
import java.awt.Toolkit;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.dnd.DnDConstants;
import java.awt.dnd.DropTarget;
import java.awt.dnd.DropTargetDragEvent;
import java.awt.dnd.DropTargetDropEvent;
import java.awt.dnd.DropTargetEvent;
import java.awt.dnd.DropTargetListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.image.BufferedImage;
import java.io.BufferedWriter;
import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.InputStream;
import java.util.List;

import javax.imageio.ImageIO;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JLayeredPane;
import javax.swing.JSlider;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import converter.tools.ColorPicker;
import converter.tools.ZoomPanel;
import converter.tools.ColorPicker.ClickListener;
import ffilechooser.FFrameListener;
import ffilechooser.FFrame;


public class MacC64HiresConverter extends JLayeredPane {

	static int width 	= 1390;
	static int height 	= 700;

	static ZoomPanel zoomPanel;

	private static FFrame frame;

	public static void main(String args[]) {

		frame = new FFrame(new FFrameListener() {

			@Override
			public void monitorResolutionChanged() {				

			}

			@Override
			public void frameResized() {

			}

			@Override
			public void frameMoved() {

			}
		});


		//frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		frame.addWindowListener(new WindowAdapter()	{
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
		});


		frame.setTitle("C64Hires Converter");
		frame.setResizable(false);

		Dimension d = Toolkit.getDefaultToolkit().getScreenSize();

		frame.setSize(width, height);
		frame.setBounds(d.width/2-width/2, d.height/2-height/2, width, height);

		// * Hide Toolbar *
		frame.setUndecorated(false);

		zoomPanel = new ZoomPanel();
		JComponent newContentPane = new MacC64HiresConverter();
		zoomPanel.add(newContentPane);

		newContentPane.setOpaque(true); 
		frame.setContentPane(zoomPanel);
		frame.setForeground(Color.WHITE);
		frame.setVisible(true);
		frame.setLayout(null);
		frame.setBackground(new Color(238,238,238));
	}


	private JLabel dropLabel;
	private JLabel originalLabel;
	private JLabel resultLabel;
	private JLabel brightnessLabel;	
	private JLabel contrastLabel;	
	private JLabel paletteRLabel;
	private JLabel paletteGLabel;
	private JLabel paletteBLabel;
	private JLabel paletteLabel;
	private JLabel pleaseWaitLabel;	
	private JLabel images;
	private JLabel interlacedImages;
	private JButton resetButton;
	private 	JButton saveButton;
	private JSlider brightnessSlider;
	private JSlider contrastSlider;
	private JSlider paletteSlider;
	private JSlider paletteRSlider;
	private JSlider paletteGSlider;
	private JSlider paletteBSlider;
	private JCheckBox showColorErrors;
	private JComboBox ditheringBox;
	private JCheckBox showInteralcedImageSelection;
	private JCheckBox animateInteralcedImageSelection;

	Font font;
	Font font2;		
	Font fontBig;
	Font consoleFont;
	Font gridFont;	


	String srcFileName 	= "";
	String srcParentDir 	= "";


	boolean mouseRelased = true;

	HiresImage hiresImage = null;


	ColorPicker colorPicker;


	boolean showInteralcedImage 		= false;
	boolean showLeftInterlacedImage 	= true;
	boolean animateInteralcedImage 	= false;


	public MacC64HiresConverter() {

		hiresImage = new HiresImage();

		font 		= new Font("Arial", Font.PLAIN, 18);
		font2 		= new Font("Arial", Font.PLAIN, 14);
		fontBig 	= new Font("Arial", Font.PLAIN, 38);
		gridFont 	= new Font("Arial", Font.PLAIN, 12);


		originalLabel = new JLabel("Original Image");
		originalLabel.setBounds( 32, 26, 240, 30 );
		originalLabel.setFont(font);
		originalLabel.setForeground(Color.BLACK);
		add(originalLabel);

		resultLabel = new JLabel("Result");
		resultLabel.setBounds( 725, 26, 240, 30 );
		resultLabel.setFont(font);
		resultLabel.setForeground(Color.BLACK);
		add(resultLabel);


		resetButton = new JButton("Reset");
		resetButton.addMouseListener(new MouseListener() {

			@Override
			public void mouseClicked(MouseEvent e) {}
			@Override
			public void mousePressed(MouseEvent e) {
				SwingUtilities.invokeLater(new Runnable() {
					public void run() {	resetAll();	}
				});
			}
			@Override
			public void mouseReleased(MouseEvent e) {}
			@Override
			public void mouseEntered(MouseEvent e) {}
			@Override
			public void mouseExited(MouseEvent e) {}			

		});
		resetButton.setBounds( 30, 510, 110, 33 );
		resetButton.setFont(font);
		resetButton.setForeground(Color.BLACK);
		add(resetButton);


		brightnessLabel = new JLabel("Brightness:");
		brightnessLabel.setBounds( 185, 510, 240, 30 );
		brightnessLabel.setFont(font);
		brightnessLabel.setForeground(Color.BLACK);
		add(brightnessLabel);

		brightnessSlider = new JSlider(JSlider.HORIZONTAL,0,1024,512);
		brightnessSlider.setToolTipText("Slide To Change Brightness");
		brightnessSlider.setMajorTickSpacing(512);
		brightnessSlider.setPaintTicks(true);
		brightnessSlider.setPaintTrack(true);
		brightnessSlider.setAutoscrolls(true);
		brightnessSlider.setBounds(270, 505, 150, 50);
		brightnessSlider.addMouseMotionListener(new MouseMotionListener() {

			public void mouseDragged(MouseEvent e) {
				hiresImage.setBrightness((255.0f/1024)*brightnessSlider.getValue());	
				SwingUtilities.invokeLater(new Runnable() {
					public void run() {	updateDestImage(); }
				});					
			}
			@Override
			public void mouseMoved(MouseEvent e) {}
		});

		add(brightnessSlider);

		contrastLabel = new JLabel("Contrast:");
		contrastLabel.setBounds(455, 510, 240, 30 );
		contrastLabel.setFont(font);
		contrastLabel.setForeground(Color.BLACK);
		add(contrastLabel);

		contrastSlider = new JSlider(JSlider.HORIZONTAL,0,1024,512);
		contrastSlider.setToolTipText("Slide To Change Contrast");
		contrastSlider.setMajorTickSpacing(512);
		contrastSlider.setPaintTicks(true);
		contrastSlider.setPaintTrack(true);
		contrastSlider.setAutoscrolls(true);
		contrastSlider.setBounds(520, 505, 150, 50);
		contrastSlider.addMouseMotionListener(new MouseMotionListener() {

			public void mouseDragged(MouseEvent e) {
				hiresImage.setContrast((2.0f/1024)*contrastSlider.getValue());	
				SwingUtilities.invokeLater(new Runnable() {
					public void run() {	updateDestImage(); }
				});		
			}
			@Override
			public void mouseMoved(MouseEvent e) {}
		});

		add(contrastSlider);

		paletteRLabel = new JLabel("R:");
		paletteRLabel.setBounds( 735, 510, 240, 30 );
		paletteRLabel.setFont(font);
		paletteRLabel.setForeground(Color.BLACK);
		add(paletteRLabel);

		paletteRSlider = new JSlider(JSlider.HORIZONTAL,0,200,100);
		paletteRSlider.setToolTipText("Slide To Change Red");
		paletteRSlider.setMajorTickSpacing(100);
		paletteRSlider.setPaintTicks(true);
		paletteRSlider.setPaintTrack(true);
		paletteRSlider.setAutoscrolls(true);
		paletteRSlider.setBounds(760, 505, 150, 50);
		paletteRSlider.addMouseMotionListener(new MouseMotionListener() {

			public void mouseDragged(MouseEvent e) {
				hiresImage.setRed(paletteRSlider.getValue());
				SwingUtilities.invokeLater(new Runnable() {
					public void run() {	updateDestImage();	}
				});		
			}
			@Override
			public void mouseMoved(MouseEvent e) {}
		});
		add(paletteRSlider);

		paletteGLabel = new JLabel("G:");
		paletteGLabel.setBounds( 965, 510, 240, 30 );
		paletteGLabel.setFont(font);
		paletteGLabel.setForeground(Color.BLACK);
		add(paletteGLabel);

		paletteGSlider = new JSlider(JSlider.HORIZONTAL,0,200,100);
		paletteGSlider.setToolTipText("Slide To Change Green");
		paletteGSlider.setMajorTickSpacing(100);
		paletteGSlider.setPaintTicks(true);
		paletteGSlider.setPaintTrack(true);
		paletteGSlider.setAutoscrolls(true);
		paletteGSlider.setBounds(980, 505, 150, 50);
		paletteGSlider.addMouseMotionListener(new MouseMotionListener() {

			public void mouseDragged(MouseEvent e) {
				hiresImage.setGreen(paletteGSlider.getValue());	
				SwingUtilities.invokeLater(new Runnable() {
					public void run() { updateDestImage(); }
				});		
			}
			@Override
			public void mouseMoved(MouseEvent e) {}
		});
		add(paletteGSlider);


		paletteBLabel = new JLabel("B:");
		paletteBLabel.setBounds(1165, 510, 240, 30 );
		paletteBLabel.setFont(font);
		paletteBLabel.setForeground(Color.BLACK);
		add(paletteBLabel);

		paletteBSlider = new JSlider(JSlider.HORIZONTAL,0,200,100);
		paletteBSlider.setToolTipText("Slide To Change Blue");
		paletteBSlider.setMajorTickSpacing(100);
		paletteBSlider.setPaintTicks(true);
		paletteBSlider.setPaintTrack(true);
		paletteBSlider.setAutoscrolls(true);
		paletteBSlider.setBounds(1180, 505, 150, 50);
		paletteBSlider.addMouseMotionListener(new MouseMotionListener() {

			public void mouseDragged(MouseEvent e) {
				hiresImage.setBlue(paletteBSlider.getValue());
				SwingUtilities.invokeLater(new Runnable() {
					public void run() { updateDestImage(); }
				});		
			}
			@Override
			public void mouseMoved(MouseEvent e) {}
		});
		add(paletteBSlider);



		paletteLabel = new JLabel("Palette:");
		paletteLabel.setBounds( 185, height-130, 240, 30 );
		paletteLabel.setFont(font);
		paletteLabel.setForeground(Color.BLACK);
		add(paletteLabel);

		paletteSlider = new JSlider(JSlider.HORIZONTAL,0,200,100);
		paletteSlider.setToolTipText("Slide To Fade Colors");
		paletteSlider.setMajorTickSpacing(100);
		paletteSlider.setPaintTicks(true);
		paletteSlider.setPaintTrack(true);
		paletteSlider.setAutoscrolls(true);
		paletteSlider.setBounds(270, height-135, 400, 50);
		paletteSlider.addMouseMotionListener(new MouseMotionListener() {

			public void mouseDragged(MouseEvent e) {
				hiresImage.setPaletteValue(paletteSlider.getValue());
				SwingUtilities.invokeLater(new Runnable() {
					public void run() {	updateDestImage(); }
				});		
			}
			@Override
			public void mouseMoved(MouseEvent e) {}
		});
		add(paletteSlider);

		showColorErrors = new JCheckBox("Show fixed Color Blocks");
		showColorErrors.setFont(font);
		showColorErrors.setSelected(false);
		showColorErrors.setBounds( 724, 574, 235, 35 );
		showColorErrors.addChangeListener(new ChangeListener() {

			@Override
			public void stateChanged(ChangeEvent e) {
				SwingUtilities.invokeLater(new Runnable() {
					public void run() {							
						updateDestImage();
						repaint();
					}
				});		
			}
		});
		add(showColorErrors);


		showInteralcedImageSelection = new JCheckBox("Use Interlaced");
		showInteralcedImageSelection.setFont(font);
		showInteralcedImageSelection.setSelected(false);
		showInteralcedImageSelection.setBounds( 1210, 25, 200, 35 );
		showInteralcedImageSelection.addChangeListener(new ChangeListener() {

			@Override
			public void stateChanged(ChangeEvent e) {
				SwingUtilities.invokeLater(new Runnable() {
					public void run() {		

						if(showInteralcedImageSelection.isSelected()) {

							animateInteralcedImageSelection.setVisible(true);
						}
						else	 {

							animateInteralcedImageSelection.setVisible(false);
							animateInteralcedImageSelection.setSelected(false);
						}
						updateDestImage();
						repaint();
					}
				});		
			}
		});
		showInteralcedImageSelection.setVisible(false);
		add(showInteralcedImageSelection);

		animateInteralcedImageSelection = new JCheckBox("Flicker");
		animateInteralcedImageSelection.setFont(font);
		animateInteralcedImageSelection.setSelected(false);
		animateInteralcedImageSelection.setBounds( 1080, 25, 235, 35 );
		animateInteralcedImageSelection.addChangeListener(new ChangeListener() {

			@Override
			public void stateChanged(ChangeEvent e) {
				SwingUtilities.invokeLater(new Runnable() {
					public void run() {		

						updateDestImage();
						repaint();
						startInterlaceLoop();
					}
				});		
			}
		});
		animateInteralcedImageSelection.setVisible(false);
		add(animateInteralcedImageSelection);


		String[] ditherings = {"No Dithering","2x2 Dithering","3x3 Dithering","4x4 Dithering","8x8 Dithering"};

		ditheringBox = new JComboBox();
		ditheringBox.setFont(font);
		ditheringBox.setModel(new DefaultComboBoxModel(ditherings));
		ditheringBox.setBounds( 727, 620, 175, 35 );
		ditheringBox.addItemListener(new ItemListener() {
			@Override
			public void itemStateChanged(ItemEvent e) {

				if (e.getStateChange() == ItemEvent.SELECTED) {
					hiresImage.setDitheringNr(ditheringBox.getSelectedIndex());	
					SwingUtilities.invokeLater(new Runnable() {
						public void run() {							
							updateDestImage();	
						}
					});		
				}
			}			
		});
		add(ditheringBox);


		// * Add Palette Boxes before the big Images Label, because the Palette Boxes must be on Top of the Screen to receive Mouse Events! *
		addPaletteBoxes();


		pleaseWaitLabel = new JLabel("", SwingConstants.CENTER);
		pleaseWaitLabel.setBounds( -10, height-131, 200, 30 );
		pleaseWaitLabel.setFont(font);
		pleaseWaitLabel.setForeground(Color.RED);
		pleaseWaitLabel.setVisible(false);
		add(pleaseWaitLabel);


		saveButton = new JButton("Save");
		saveButton.addMouseListener(new MouseListener() {

			@Override
			public void mouseClicked(MouseEvent e) {}
			@Override
			public void mousePressed(MouseEvent e) {				
				convert();					
			}
			@Override
			public void mouseReleased(MouseEvent e) {}
			@Override
			public void mouseEntered(MouseEvent e) {}
			@Override
			public void mouseExited(MouseEvent e) {}			

		});
		saveButton.setBounds( 30, height-80, 110, 33 );
		saveButton.setFont(font);
		saveButton.setForeground(Color.BLACK);
		add(saveButton);


		interlacedImages = new JLabel() {

			public void paintComponent(Graphics gr) {
				super.paintComponent(gr);

				if(hiresImage.getDestImageInterlacedLeft() != null && hiresImage.getDestImageInterlacedRight() != null) {

					if(showLeftInterlacedImage) 	gr.drawImage(hiresImage.getDestImageInterlacedLeft(), 720, 80, 640,400, null);
					else							gr.drawImage(hiresImage.getDestImageInterlacedRight(), 720, 80, 640,400, null);						
				}
				gr.dispose();
			}
		};

		interlacedImages.setBounds( 0, 0, width, height);
		add(interlacedImages);


		images = new JLabel() {

			public void paintComponent(Graphics gr) {
				super.paintComponent(gr);

				if(hiresImage.getSrcImage() != null) {
					gr.drawImage(hiresImage.getSrcImage(), 30, 80, 640,400, null);					
				}

				if(hiresImage.getDestImage() != null) {

					if(!showInteralcedImageSelection.isSelected()) 	gr.drawImage(hiresImage.getDestImage(), 720, 80, 640,400, null);		
					else												gr.drawImage(hiresImage.getDestImageInterlaced(), 720, 80, 640,400, null);		

					if(showColorErrors.isSelected()) {

						if(!showInteralcedImageSelection.isSelected()) 	gr.drawImage(hiresImage.getDestImageNotReduced(), 720, 80, 640,400, null);		
						else												gr.drawImage(hiresImage.getDestImageInterlacedNotReduced(), 720, 80, 640,400, null);		

						gr.setFont(gridFont);

						int block = 0;
						for(int y=0;y<400;y+=16) {

							gr.setColor(new Color(120,120,120));
							gr.drawLine(720+0, 80+y, 720+640, 80+y);

							for(int x=0;x<640;x+=16) {

								gr.setColor(new Color(120,120,120));
								gr.drawLine(720+x, 80+0, 720+x, 80+400);

								if(hiresImage.blocks[block].colorsUsedCount > 4) {

									gr.setColor(new Color(20,20,20));
									gr.drawString("" + hiresImage.blocks[block].colorsUsedCount, 720+x -1 + gridFont.getSize()/2, 80+y-1 + gridFont.getSize());
									gr.setColor(new Color(20,20,20));
									gr.drawString("" + hiresImage.blocks[block].colorsUsedCount, 720+x +1 + gridFont.getSize()/2, 80+y +1 + gridFont.getSize());
									gr.setColor(new Color(255,255,255));
									gr.drawString("" + hiresImage.blocks[block].colorsUsedCount, 720+x + gridFont.getSize()/2, 80+y + gridFont.getSize());
								}
								block++;
							}									
						}		

						block = 0;
						for(int y=0;y<400;y+=16) {

							for(int x=0;x<640;x+=16) {

								if(hiresImage.blocks[block].colorsUsedCount > 4) {

									gr.setColor(new Color(255,255,255,250));
									gr.drawRect(720+x, 80+y, 16, 16);
								}
								block++;
							}									
						}		
					}
				}
				gr.dispose();
			}
		};

		images.setBounds( 0, 0, width, height);
		images.addMouseListener(new MouseListener() {

			@Override
			public void mouseClicked(MouseEvent e) {}

			@Override
			public void mousePressed(MouseEvent e) {
				if(e.getX() > 720 && e.getX() < 720+640 && 
						e.getY() > 80 && e.getY() < 80+400) {
					zoomPanel.moveShape(e);
				}
				else {

					if(zoomPanel.s != null) {
						zoomPanel.s = null;
						zoomPanel.repaint();
					}
				}
			}

			@Override
			public void mouseReleased(MouseEvent e) {

				if(zoomPanel.s != null) {
					zoomPanel.s = null;
					zoomPanel.repaint();
				}			
			}

			@Override
			public void mouseEntered(MouseEvent e) {}

			@Override
			public void mouseExited(MouseEvent e) {}

		});

		images.addMouseMotionListener(new MouseMotionListener() {

			public void mouseDragged(MouseEvent e) {

				if(e.getX() > 720 && e.getX() < 720+640 && e.getY() > 80 && e.getY() < 80+400) {
					zoomPanel.moveShape(e);
				}
				else {

					if(zoomPanel.s != null) {
						zoomPanel.s = null;
						zoomPanel.repaint();
					}
				}
			}

			@Override
			public void mouseMoved(MouseEvent e) {}
		});		

		add(images);


		dropLabel = new JLabel("DROP AN IMAGE HERE", SwingConstants.CENTER);
		dropLabel.setBounds( 0, 0, width, height );
		dropLabel.setFont(fontBig);
		dropLabel.setForeground(Color.GRAY);
		dropLabel.setVisible(true);
		add(dropLabel);


		JLabel label3 = new JLabel("Design by Matthias", SwingConstants.CENTER);
		label3.setFont(font2);
		label3.setForeground(Color.BLACK);	
		label3.setBounds(width - 215, height - 105, 200, 100);
		add(label3);

		DropJLabel waveformScreen = new DropJLabel();		
		waveformScreen.setBounds(0, 0, width, height);	
		waveformScreen.setFocusable(true);
		add(waveformScreen);

		DropTarget dropTarget1 = new DropTarget(waveformScreen, waveformScreen);


		hiresImage.setPaletteValue(paletteSlider.getValue());


		hideUI();
	}

	JLabel[] paletteBoxes = new JLabel[16];

	int selectedColor = -1;

	private void addPaletteBoxes() {

		for(int i=0;i<16;i++) {

			final int nr = i;
			final Stroke stroke = new BasicStroke(3f);

			JLabel box = new JLabel() {

				@Override
				public void paintComponent(Graphics gr) {
					super.paintComponent(gr);

					Graphics2D gr2D = (Graphics2D)gr;

					gr2D.setColor(new Color(hiresImage.getDestColorsRGB()[nr][0],hiresImage.getDestColorsRGB()[nr][1],hiresImage.getDestColorsRGB()[nr][2]));
					gr2D.fillRect(0, 0, getWidth(), getHeight());

					if(selectedColor == nr) {

						gr2D.setStroke(stroke);
						gr2D.setColor(new Color(255,0,0));
						gr2D.drawRect(2, 2, getWidth()-4, getHeight()-4);
					}	
				}				
			};
			box.setBounds( 184+i*30, height-80, 30, 30 );
			box.setOpaque(true);
			box.setBackground(new Color(hiresImage.getDestColorsRGB()[i][0],hiresImage.getDestColorsRGB()[i][1],hiresImage.getDestColorsRGB()[i][2]));

			box.addMouseListener(new MouseListener() {

				final int colorNr = nr;

				@Override
				public void mouseClicked(MouseEvent e) {}
				@Override
				public void mousePressed(MouseEvent e) {

					selectedColor = colorNr;
					repaint();

					if(colorPicker != null) {

						colorPicker.dispose();
						colorPicker = null;
					}

					colorPicker = new ColorPicker(frame, new ClickListener() {

						@Override
						public void okClicked() {

							hiresImage.getSrcColorsRGB()[colorNr][0] = colorPicker.getForegroundColor().getRed();
							hiresImage.getSrcColorsRGB()[colorNr][1] = colorPicker.getForegroundColor().getGreen();
							hiresImage.getSrcColorsRGB()[colorNr][2] = colorPicker.getForegroundColor().getBlue();

							SwingUtilities.invokeLater(new Runnable() {
								public void run() {
									hiresImage.updatePalette();
									updateDestImage();	
								}
							});		
						}						
					}, new Color(hiresImage.getSrcColorsRGB()[colorNr][0],hiresImage.getSrcColorsRGB()[colorNr][1],hiresImage.getSrcColorsRGB()[colorNr][2]));	
				}
				@Override
				public void mouseReleased(MouseEvent e) {}
				@Override
				public void mouseEntered(MouseEvent e) {}
				@Override
				public void mouseExited(MouseEvent e) {}

			});			

			add(box);
			paletteBoxes[i] = box;		
		}		
	}


	private void showUI() {

		originalLabel.setVisible(true);
		resultLabel.setVisible(true);
		brightnessLabel.setVisible(true);
		contrastLabel.setVisible(true);	
		paletteRLabel.setVisible(true);
		paletteGLabel.setVisible(true);
		paletteBLabel.setVisible(true);
		paletteLabel.setVisible(true);
		pleaseWaitLabel.setVisible(true);
		images.setVisible(true);
		resetButton.setVisible(true);
		saveButton.setVisible(true);
		brightnessSlider.setVisible(true);
		contrastSlider.setVisible(true);
		paletteSlider.setVisible(true);
		paletteRSlider.setVisible(true);
		paletteGSlider.setVisible(true);
		paletteBSlider.setVisible(true);
		showColorErrors.setVisible(true);
		ditheringBox.setVisible(true);
		showInteralcedImageSelection.setVisible(true);

		for(int i=0;i<16;i++) paletteBoxes[i].setVisible(true);
	}

	private void hideUI() {

		originalLabel.setVisible(false);
		resultLabel.setVisible(false);
		brightnessLabel.setVisible(false);
		contrastLabel.setVisible(false);	
		paletteRLabel.setVisible(false);
		paletteGLabel.setVisible(false);
		paletteBLabel.setVisible(false);
		paletteLabel.setVisible(false);
		pleaseWaitLabel.setVisible(false);
		images.setVisible(false);
		resetButton.setVisible(false);
		saveButton.setVisible(false);
		brightnessSlider.setVisible(false);
		contrastSlider.setVisible(false);
		paletteSlider.setVisible(false);
		paletteRSlider.setVisible(false);
		paletteGSlider.setVisible(false);
		paletteBSlider.setVisible(false);
		showColorErrors.setVisible(false);
		ditheringBox.setVisible(false);
		showInteralcedImageSelection.setVisible(false);
		interlacedImages.setVisible(false);

		for(int i=0;i<16;i++) paletteBoxes[i].setVisible(false);
	}


	public void updateSrcImage(BufferedImage image) {
		if(image == null) return;

		showLoadingState(true);
		pleaseWaitLabel.setForeground(Color.DARK_GRAY);
		pleaseWaitLabel.setText("Updating...");

		try {

			hiresImage.createSrcImage(image);
			images.repaint();
		} 
		catch (Exception e) {
			e.printStackTrace();

			pleaseWaitLabel.setForeground(Color.RED);
			pleaseWaitLabel.setText("Error!");

			try {
				Thread.sleep(2000);
			} catch (InterruptedException e1) {
				e1.printStackTrace();
			}
		}

		showLoadingState(false);
	}


	public void updateDestImage() {

		if(hiresImage.getSrcImage() == null) return;

		try {

			pleaseWaitLabel.setForeground(Color.DARK_GRAY);
			pleaseWaitLabel.setText("Updating...");

			hiresImage.updateDestImages(showInteralcedImageSelection.isSelected());

			images.repaint();
		} 
		catch (Exception e) {
			e.printStackTrace();

			pleaseWaitLabel.setForeground(Color.RED);
			pleaseWaitLabel.setText("Error!");

			try {
				Thread.sleep(2000);
			} catch (InterruptedException e1) {
				e1.printStackTrace();
			}
		}

		showLoadingState(false);
	}


	public void convert() {

		if(hiresImage.getSrcImage() == null) return;

		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				saveButton.setEnabled(false);	

				pleaseWaitLabel.setVisible(true);
				pleaseWaitLabel.setForeground(Color.DARK_GRAY);
				pleaseWaitLabel.setText("Saving...");
			}
		});

		
		// * Use a background Thread *
		Thread T=new Thread(new Runnable() {

			@Override
			public void run() {	

				try {

					Thread.sleep(500);

					byte[] rawData = hiresImage.convertToRawData(showInteralcedImageSelection.isSelected());
					if(rawData == null) return;

					int lastPeriodPos = srcFileName.lastIndexOf('.');
					if (lastPeriodPos > 0) srcFileName = srcFileName.substring(0, lastPeriodPos);					

					if(!showInteralcedImageSelection.isSelected()) {
						try	{ 

							byte[] prgData = null;

							InputStream in = getClass().getResourceAsStream("/hires.prg");
							ByteArrayOutputStream os = new ByteArrayOutputStream(); 
							byte[] buffer = new byte[0xFFFF];
							for (int len = in.read(buffer); len != -1; len = in.read(buffer)) os.write(buffer, 0, len);
							
							prgData = os.toByteArray();

							for(int i=0;i<8000;i++) prgData[0x1801 + i] = rawData[i];
							for(int i=0;i<1000;i++) prgData[0x3741 + i] = rawData[0x2000+i];
							for(int i=0;i<1000;i++) prgData[0x3B29 + i] = rawData[0x2400+i];
							
							// * Screen Frame Color *
							prgData[0x835] = (byte) 0;

							// * Image Background Color: Color #4 *
							prgData[0x83a] = (byte) hiresImage.getBackgroundColorPaletteIndex();

							// * Write PRG File *
							File prgFile = new File(srcParentDir + "/" + srcFileName + "_converted.prg");
							System.out.println(prgFile.getAbsolutePath());
							
							if(prgFile.exists()) prgFile.delete();
							DataOutputStream localDataOutputStream = new DataOutputStream(new FileOutputStream(prgFile));
							localDataOutputStream.write(prgData);
							localDataOutputStream.close();	
						} 
						catch( Exception e ) { e.printStackTrace();	}
					}
					else {
						
						byte[] prgData = null;

						InputStream in = getClass().getResourceAsStream("/hires_interlaced.prg");
						ByteArrayOutputStream os = new ByteArrayOutputStream(); 
						byte[] buffer = new byte[0xFFFF];
						for (int len = in.read(buffer); len != -1; len = in.read(buffer)) os.write(buffer, 0, len);
						
						prgData = os.toByteArray();

						for(int i=0;i<8000;i++) prgData[0x1801 + i] = rawData[i];
						for(int i=0;i<8000;i++) prgData[0x1801 + 0x4000 + i] = rawData[0x2000+i];
						
						for(int i=0;i<1000;i++) prgData[0x4801 + i] = rawData[0x4000+i];
						for(int i=0;i<1000;i++) prgData[0x4801 + 0x400 + i] = rawData[0x4400+i];
						

						// * Screen Frame Color *
						prgData[0x83F] = (byte) 0;

						// * Image Background Color: Color #4 *
						prgData[0x844] = (byte) hiresImage.getBackgroundColorPaletteIndex();

						// * Write PRG File *
						File prgFile = new File(srcParentDir + "/" + srcFileName + "_converted_interlaced.prg");
						System.out.println(prgFile.getAbsolutePath());
						
						if(prgFile.exists()) prgFile.delete();
						DataOutputStream localDataOutputStream = new DataOutputStream(new FileOutputStream(prgFile));
						localDataOutputStream.write(prgData);
						localDataOutputStream.close();	
					}

					

					// * Write PNG Files *

					if(!showInteralcedImageSelection.isSelected()) {

						File f = new File(srcParentDir + "/" + srcFileName + "_converted.png");
						if(f.exists()) f.delete();		
						ImageIO.write(hiresImage.getDestImage(), "png", f);
					}
					else {

						File f = new File(srcParentDir + "/" + srcFileName + "_converted_interlaced.png");
						if(f.exists()) f.delete();		
						ImageIO.write(hiresImage.getDestImageInterlaced(), "png", f);
						f = new File(srcParentDir + "/" + srcFileName + "_converted_interlaced_left.png");
						if(f.exists()) f.delete();		
						ImageIO.write(hiresImage.getDestImageInterlacedLeft(), "png", f);
						f = new File(srcParentDir + "/" + srcFileName + "_converted_interlaced_right.png");
						if(f.exists()) f.delete();		
						ImageIO.write(hiresImage.getDestImageInterlacedRight(), "png", f);
					}

					if(!showInteralcedImageSelection.isSelected()) {

						// *  Write RAW Data (Bitmap, ColorRam, Character Color) *
						File rawFile = new File(srcParentDir + "/" + srcFileName + "_converted.raw");
						if(rawFile.exists()) rawFile.delete();		
						DataOutputStream localDataOutputStream = new DataOutputStream(new FileOutputStream(rawFile));
						localDataOutputStream.write(rawData);
						localDataOutputStream.close();
					}
					else {

						// *  Write RAW Data (Bitmap, ColorRam, Character Color) *
						File rawFileInterlaced = new File(srcParentDir + "/" + srcFileName + "_converted_interlaced.raw");
						if(rawFileInterlaced.exists()) rawFileInterlaced.delete();		
						DataOutputStream localDataOutputStream = new DataOutputStream(new FileOutputStream(rawFileInterlaced));
						localDataOutputStream.write(rawData);
						localDataOutputStream.close();
					}

					// * Write Info Text File *
					BufferedWriter writer = null;
					try {

						String ending = "_converted.txt";
						if(showInteralcedImageSelection.isSelected()) ending = "_converted_interlaced.txt";
						
						File textFile = new File(srcParentDir + "/" + srcFileName + ending);	
						if(textFile.exists()) textFile.delete();	
						writer = new BufferedWriter(new FileWriter(textFile));
						if(!showInteralcedImageSelection.isSelected()) writer.write("\nData File Infos:\n----------------\n\nBitmap Data       (2000): 0000-1FFF\nScreen Ram Data   (0400): 2000-23FF\nColor Ram Data    (D800): 2800-2B00\nBackground Color  (D021): " + hiresImage.getBackgroundColorPaletteIndex() + "\n\n\nCreated by C64Hires Converter");
						else 										  writer.write("\nData File Infos:\n----------------\n\nLeft Bitmap Data  (2000): 0000-1FFF\nRight Bitmap Data (6000): 2000-3FFF\nScreen Ram Data   (0400/4400): 4000-43FF\nColor Ram Data    (D800): 4400-4800\nBackground Color  (D021): " + hiresImage.getBackgroundColorPaletteIndex() + "\n\n\nCreated by C64Hires Converter");
					} 
					catch (Exception e) {
						e.printStackTrace();
					} 
					finally {
						try {

							writer.close();
						} catch (Exception e) {
						}
					}

					Thread.sleep(500);

					SwingUtilities.invokeLater(new Runnable() {
						public void run() {
							pleaseWaitLabel.setForeground(Color.BLACK);
							pleaseWaitLabel.setText("Ready!");
						}
					});

					Thread.sleep(500);

				} catch (Exception e) {
					e.printStackTrace();


					SwingUtilities.invokeLater(new Runnable() {
						public void run() {

							pleaseWaitLabel.setForeground(Color.RED);
							pleaseWaitLabel.setText("Error!");
						}
					});

					try {
						Thread.sleep(2000);
					} catch (InterruptedException e1) {
						e1.printStackTrace();
					}
				}

				SwingUtilities.invokeLater(new Runnable() {
					public void run() {
						saveButton.setEnabled(true);
						showLoadingState(false);
					}
				});
			}
		});

		T.start();
	}


	private void resetAll() {

		selectedColor = -1;

		brightnessSlider.setValue(430);
		contrastSlider.setValue(440);				
		paletteSlider.setValue(110);		
		paletteRSlider.setValue(100);
		paletteGSlider.setValue(100);
		paletteBSlider.setValue(100);

		ditheringBox.setSelectedIndex(1);

		hiresImage.reset();
		hiresImage.updateDestImages(showInteralcedImageSelection.isSelected());

		images.repaint();
	}


	public void loadFile(final File file) {

		resetAll();

		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				dropLabel.setVisible(false);
				showLoadingState(true);
				pleaseWaitLabel.setForeground(Color.DARK_GRAY);
				pleaseWaitLabel.setText("Loading...");
			}
		});		

		try {

			BufferedImage loadedImage = ImageIO.read(file);

			srcFileName 		= file.getName();
			srcParentDir 	= file.getParent();

			SwingUtilities.invokeLater(new Runnable() {
				public void run() {

					updateSrcImage(loadedImage);
					updateDestImage();
				}
			});			
		} 
		catch (Exception e) {
			e.printStackTrace();

			SwingUtilities.invokeLater(new Runnable() {
				public void run() {
					pleaseWaitLabel.setForeground(Color.RED);
					pleaseWaitLabel.setText("Error!");
				}
			});					

			try {
				Thread.sleep(2000);
			} catch (InterruptedException e1) {
				e1.printStackTrace();
			}
		}

		SwingUtilities.invokeLater(new Runnable() {
			public void run() {

				showUI();
				showLoadingState(false);
			}
		});		
	}


	private void showLoadingState(final boolean state) {

		pleaseWaitLabel.setVisible(state);
	}


	public class DropJLabel extends JLabel implements DropTargetListener {

		public DropJLabel() {		

		}

		public DropJLabel(String text) {			
			super.setText(text);
		}

		@Override
		public void dragEnter(DropTargetDragEvent dtde) {}
		@Override
		public void dragOver(DropTargetDragEvent dtde) {}
		@Override
		public void dropActionChanged(DropTargetDragEvent dtde) {}
		@Override
		public void dragExit(DropTargetEvent dte) {}
		@Override
		public void drop(DropTargetDropEvent evt) {

			try {

				evt.acceptDrop(DnDConstants.ACTION_COPY_OR_MOVE);
				Transferable t = evt.getTransferable();
				List fileList = (List)t.getTransferData(DataFlavor.javaFileListFlavor);
				File f = (File)fileList.get(0);

				if(f.isFile()) loadFile(f);	
			}
			catch(Exception e)  { e.printStackTrace();}
		}		
	}


	private void startInterlaceLoop() {

		interlacedImages.setVisible(true);

		// * Use a background Thread to get the Remote Data from the Arduino  *
		Thread T=new Thread(new Runnable() {

			@Override
			public void run() {	

				try {

					while(showInteralcedImageSelection.isSelected() && animateInteralcedImageSelection.isSelected()) {

						Thread.sleep(15);

						if(showLeftInterlacedImage) 	showLeftInterlacedImage = false;
						else							showLeftInterlacedImage = true;

						SwingUtilities.invokeLater(new Runnable() {
							public void run() {
								interlacedImages.repaint();
							}
						});
					}

					interlacedImages.setVisible(false);
				}
				catch(Exception e) {

				}
			}
		});

		T.setPriority(Thread.MIN_PRIORITY);
		T.start();
	}
}
