package ffilechooser;


import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.MouseInfo;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.event.ActionEvent;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;
import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.Vector;
import java.util.prefs.Preferences;

import javax.swing.AbstractAction;
import javax.swing.AbstractCellEditor;
import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.KeyStroke;
import javax.swing.RowSorter;
import javax.swing.SortOrder;
import javax.swing.SwingUtilities;
import javax.swing.border.Border;
import javax.swing.border.LineBorder;
import javax.swing.border.MatteBorder;
import javax.swing.event.CellEditorListener;
import javax.swing.event.ChangeEvent;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellEditor;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;
import javax.swing.table.TableModel;
import javax.swing.table.TableRowSorter;
import javax.swing.text.BadLocationException;


public class DirectoryTable extends JTable  {


	static Preferences prefs = Preferences.userNodeForPackage(DirectoryTable.class);	
	final static String PREF_NAME_column 	= "column";
	final static String PREF_NAME_order 		= "order";


	private JScrollPane accountListScrollPane;

	DefaultTableModel tableModel;
	TableRowSorter fSorter;
	SortOrder currentOrder = SortOrder.ASCENDING;
	public int oldSelectedHeaderColumn = 0;


	Directory directory;
	DirectoryTable directoryTable;


	long doubleClicktime 		= System.currentTimeMillis();
	int doubleClickCount 		= 0;
	boolean doubleClick 			= false;
	int doubleClickGrenze 		= 400;
	int oldRow 					= -1;



	public void changeSelection(int rowIndex, int columnIndex, boolean toggle, boolean extend) {

		boolean selected = false;
		int[] rows = this.getSelectedRows();
		for(int i=0;i<rows.length;i++) if(rowIndex == rows[i])  selected = true;


		// * Wenn diese Row noch nicht selektiert, dann Selektion zulassen * 				
		super.changeSelection(rowIndex, columnIndex, toggle, extend);		
	}



	public DirectoryTable(final Directory directory) {

		this.directory = directory;
		this.directoryTable = this;


		tableModel = new DefaultTableModel() {

			@Override
			public boolean isCellEditable(int row, int column) {

				return false;
			}
		};
		setModel(tableModel);




		setAutoCreateRowSorter(false);
		addFocusListener(new FocusListener() {
			@Override
			public void focusGained(FocusEvent arg0) {	

			}
			@Override
			public void focusLost(FocusEvent arg0) {	

			}			
		});
		setFillsViewportHeight( true );
		fSorter = new TableRowSorter<TableModel>(getModel());


		setShowGrid(false);
		setShowVerticalLines(false);
		setIntercellSpacing( new Dimension(0, 0) );       
		setRowSorter(fSorter);
		setRowMargin(1);

		// * Verhindert im Row Edit-Mode, dass nach ENTER die naechste Zeile aktiviert wird *
		getInputMap(JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT).put(KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, 0, false), "selectNextColumnCell");



		// * Row Height *
		setRowHeight( directory.directoryTableRowHeight );

		// * Linien-Border Weiss oben *
		setBorder(new MatteBorder(2,0,0,0,Color.WHITE)); 

		// * Linien-Border Grau unten *
		getTableHeader().setBorder(new MatteBorder(0,0,1,0,Color.LIGHT_GRAY)); 


		getTableHeader().setReorderingAllowed( false );
		getTableHeader().setResizingAllowed( true );			
		getTableHeader().setBackground(new Color(0xf0f0f0));
		getTableHeader().setForeground(Color.BLACK);

		// * Header Height *
		getTableHeader().setPreferredSize(new Dimension(getWidth(), directory.directoryTableHeaderRowHeight));

		// * Header *
		TableCellRenderer baseRenderer = getTableHeader().getDefaultRenderer();
		getTableHeader().setDefaultRenderer(new TableHeaderRenderer(baseRenderer));
		getTableHeader().setFont(directory.directoryTableHeaderFont);
		getTableHeader().setEnabled(false); // !!!!!! Sehr wichtig, das verhindert die Standard Header Events (doppelte Sortierungen!)
		getTableHeader().addMouseListener(new MouseListener() {

			@Override
			public void mouseReleased(MouseEvent e) {}

			@Override
			public void mouseClicked(MouseEvent e) {	}

			@Override
			public void mousePressed(MouseEvent e) {	

				if(e.getButton() != 1) return;

				int column = getTableHeader().columnAtPoint(e.getPoint());


				columnEvent(column);

			}

			@Override
			public void mouseEntered(MouseEvent e) {	}

			@Override
			public void mouseExited(MouseEvent e) {	}
		});

		setFont(directory.directoryTableFont);




		// **** MAIN Listeners ****


		addFocusListener(new FocusListener() {

			@Override
			public void focusGained(FocusEvent arg0) {		

				directory.activateDirectory();
			}

			@Override
			public void focusLost(FocusEvent arg0) {	
			}			
		});

		addMouseMotionListener(new MouseMotionListener() {

			@Override
			public void mouseDragged(MouseEvent e) {				
			}

			@Override
			public void mouseMoved(MouseEvent e) {	
			}
		});

		addMouseListener(new MouseListener() {

			@Override
			public void mouseClicked(MouseEvent event) {}

			@Override
			public void mouseEntered(MouseEvent arg0) {}

			@Override
			public void mouseExited(MouseEvent arg0) {}

			@Override
			public void mousePressed(MouseEvent event) {	}

			@Override
			public void mouseReleased(MouseEvent event) {

				if(event.getButton() != 1) return;

				final int row 		= rowAtPoint(event.getPoint());
				final int column 	= columnAtPoint(event.getPoint());

				boolean clickNameHasChanged = false;				
				if(row == -1 || column == -1 || getValueAt(row, 1) == null) {

					clickNameHasChanged = true;
					return;
				}


				// * Directory Double Click Routine *
				if(clickNameHasChanged) {

					doubleClick 	= false;
					doubleClickCount = 1;
					doubleClicktime = System.currentTimeMillis();	

					// * Wenn eine Zeile angeklickt wurde, und keine Sondertasten gedrueckt um Mehrfachselektion zu starten, dann alle anderen selektierten Zeilen deselektieren  *
					if(event.isShiftDown() == false && event.isMetaDown() == false &&  event.isAltDown() == false) directory.directoryTable.setRowSelectionInterval(row, row);	
				}
				else {

					if(System.currentTimeMillis() - doubleClicktime >= doubleClickGrenze || oldRow != row) {

						doubleClick 	= false;
						doubleClickCount = 1;
						doubleClicktime = System.currentTimeMillis();
						oldRow = row;
					}
					else {

						doubleClickCount++;						
						if(doubleClickCount >= 2) doubleClick = true;
						doubleClicktime = System.currentTimeMillis();
					}
				}



				// * Directory Laden / oder APP starten, sowie "Wait Mouse Cursor" anzeigen! *

				if(doubleClick) {

					doubleClickCount 	= 0;

					if(row != -1 && column != -1) directory.doubleClickedDirectoryColumn((String)getValueAt(row, 1));					
				}	
				else {

					if(row != -1 || column != -1) directory.clickedDirectoryColumn((String)getValueAt(row, 1));						
				}
			}
		});	



		// * Mouse Wheel Speed Scroll Korrektur *
		addMouseWheelListener(new MouseWheelListener() {

			@Override
			public void mouseWheelMoved(MouseWheelEvent e) {

				accountListScrollPane.getVerticalScrollBar().setUnitIncrement(5*Math.abs(e.getWheelRotation()));
				accountListScrollPane.dispatchEvent(e);				        
			}
		});



		addKeyListener(new KeyListener() {

			@Override
			public void keyTyped(KeyEvent e) {}

			@Override
			public void keyPressed(KeyEvent event) {	}

			@Override
			public void keyReleased(KeyEvent event) {}
		});



		accountListScrollPane = new JScrollPane(this);
		accountListScrollPane.setBorder(new LineBorder(Color.LIGHT_GRAY, 1));



		AbstractAction selectAll = new AbstractAction() {

			public void actionPerformed(ActionEvent evt) {

				try {

					int endRow = directoryTable.getRowCount()-1;
					for(int i=0;i<directoryTable.getRowCount();i++) {

						if(directoryTable.getValueAt(i, 1) == null) {

							endRow = i-1;
							break;
						}
					}	

					directory.directoryTable.setRowSelectionInterval(0, endRow);							
				}
				catch (Exception e) {e.printStackTrace(); Toolkit.getDefaultToolkit().beep();}
			}			
		};

		AbstractAction directoryExchangeAction = new AbstractAction() {

			public void actionPerformed(ActionEvent evt) {
				try {

					String p = directory.directoryPath;
					directory.directoryPath = directory.directoryPath;
					directory.directoryPath = p;

					directory.reloadDir();
					directory.reloadDir();

				}
				catch (Exception e) {e.printStackTrace(); Toolkit.getDefaultToolkit().beep();}
			}			
		};		
	}


	public SortOrder getSavedOrder() {

		if(prefs.get(PREF_NAME_order, "").compareTo("ASCENDING") == 0) 	return SortOrder.ASCENDING;
		else																return SortOrder.DESCENDING;
	}

	public int getSavedCloumn() {

		return prefs.getInt(PREF_NAME_column, 1);
	}


	public void columnEvent(int column) {

		final RowSorter sorter = getRowSorter();
		final List sortKeys = new ArrayList();

		directory.activateDirectory();

		// * Wurde ein anderes Table Header angeklickt als zuvor, dann SortOrder auf unsorted stellen, damit zuerst immer von "oben" sortieren erfolgt *
		if(oldSelectedHeaderColumn != column) currentOrder = SortOrder.DESCENDING;

		doSortingTable(column, sorter, sortKeys, true);

		oldSelectedHeaderColumn = column;

		if(currentOrder == SortOrder.ASCENDING) 	prefs.put(PREF_NAME_order, "ASCENDING");
		else 									prefs.put(PREF_NAME_order, "DESCENDING");

		prefs.putInt(PREF_NAME_column, column);

	}



	public JScrollPane getScrollPane() {

		return accountListScrollPane;
	}

	public void selectRow(String fileName) {

		try {

			for(int i=0;i<directoryTable.getRowCount();i++) {

				String name = ((String)directoryTable.getValueAt(i, 1));
				if(name != null) {
					
					if(name.compareTo(fileName) == 0) {

						super.changeSelection(i, 1, false, false);	
						directory.clickedDirectoryColumn((String)getValueAt(i, 1));		
						break;
					}
				}
			}								
		}
		catch (Exception e) {e.printStackTrace(); Toolkit.getDefaultToolkit().beep();}

	}

	synchronized public void fillTableWithEmptyRows() {

		// * Leere Zeilen entfernen *
		try {
			for(int i=0;i<tableModel.getRowCount();i++) {			

				if(tableModel.getValueAt(i, 1) == null)  tableModel.removeRow(i);			
			}
		}
		catch(Exception e) {e.printStackTrace();}

		// * Mit leeren Zeilen auffüllen *
		int rows 		= tableModel.getRowCount();
		int rowHeight 	= getRowHeight();
		int tableHeight 	= getTableHeader().getHeight()+(rows*rowHeight);

		while( tableHeight < accountListScrollPane.getViewport().getHeight()) {

			tableModel.addRow(new Object[]{null,null,null,null,null});
			tableHeight+=rowHeight;
		}
	}

	public void sortColumn(int column, boolean nextSortOrder) {

		final RowSorter sorter = getRowSorter();
		final List sortKeys = new ArrayList();

		// * Wurde ein anderes Table Header angeklickt als zuvor, dann SortOrder auf unsorted stellen, damit zuerst immer von "oben" sortieren erfolgt *
		if(oldSelectedHeaderColumn != column) currentOrder = SortOrder.DESCENDING;

		doSortingTable(column, sorter, sortKeys, nextSortOrder);		
	}

	public void doSortingTable(int column, RowSorter sorter, List sortKeys, boolean nextSortOrder) {

		if(column == 1) {

			if(nextSortOrder) {

				if(currentOrder == SortOrder.UNSORTED || currentOrder == SortOrder.DESCENDING) 	currentOrder = SortOrder.ASCENDING;
				else 																			currentOrder = SortOrder.DESCENDING;
			}

			switch (currentOrder) {
			case UNSORTED:			
			case DESCENDING:

				fSorter.setComparator(column, new StringComparator(SortOrder.DESCENDING));	    
				sortKeys.add(new RowSorter.SortKey(column, SortOrder.DESCENDING));
				sorter.setSortKeys(sortKeys);					
				sortTable(directoryTable, column, ".....");
				break;
			case ASCENDING:

				fSorter.setComparator(column, new StringComparator(SortOrder.ASCENDING));
				sortKeys.add(new RowSorter.SortKey(column, SortOrder.ASCENDING));
				sorter.setSortKeys(sortKeys);
				sortTable(directoryTable, column, "ZZZZZZZZZZZZZZZZZZZZZZZZ");	
				break;					
			}
		}

		if(column == 2) {

			if(nextSortOrder) {

				if(currentOrder == SortOrder.UNSORTED || currentOrder == SortOrder.DESCENDING) 	currentOrder = SortOrder.ASCENDING;
				else 																			currentOrder = SortOrder.DESCENDING;
			}

			switch (currentOrder) {
			case UNSORTED:
			case DESCENDING:

				fSorter.setComparator(column, new FileSizeComparator(SortOrder.DESCENDING));	    
				sortKeys.add(new RowSorter.SortKey(column, SortOrder.DESCENDING));
				sorter.setSortKeys(sortKeys);				
				sortTable(directoryTable, column, "-------------------------");	
				break;

			case ASCENDING:

				fSorter.setComparator(column, new FileSizeComparator(SortOrder.ASCENDING));
				sortKeys.add(new RowSorter.SortKey(column, SortOrder.ASCENDING));
				sorter.setSortKeys(sortKeys);
				sortTable(directoryTable, column, "ZZZZZZZZZZZZZZZZZZZZZZZZ");		
				break;
			}					
		}

		if(column == 3) {

			if(nextSortOrder) {

				if(currentOrder == SortOrder.UNSORTED || currentOrder == SortOrder.DESCENDING) 	currentOrder = SortOrder.ASCENDING;
				else 																			currentOrder = SortOrder.DESCENDING;
			}

			switch (currentOrder) {
			case UNSORTED:			
			case DESCENDING:

				fSorter.setComparator(column, new FileDateComparator(SortOrder.DESCENDING));	    
				sortKeys.add(new RowSorter.SortKey(column, SortOrder.DESCENDING));
				sorter.setSortKeys(sortKeys);			
				sortTable(directoryTable, column, " 0");	
				break;
			case ASCENDING:

				fSorter.setComparator(column, new FileDateComparator(SortOrder.ASCENDING));
				sortKeys.add(new RowSorter.SortKey(column, SortOrder.ASCENDING));
				sorter.setSortKeys(sortKeys);
				sortTable(directoryTable, column, "ZZZZZ");
				break;					
			}
		}
	}


	// * synchronized ist wichtig!!! Weil wenn man im Header eine Sortierung aktiviert... die Icons in der Tabelle nicht mehr angezeigt werden! *
	synchronized public void sortTable(JTable directory, int column, String chars) {

		int rows = tableModel.getRowCount();
		for(int i=0;i<rows;i++) {

			if(tableModel.getValueAt(i, column) == null) {

				tableModel.setValueAt(chars, i, column);								
			}
		}							

		tableModel.fireTableDataChanged();

		rows = tableModel.getRowCount();
		for(int i=0;i<rows;i++) {

			if(tableModel.getValueAt(i, column).toString().compareTo(chars) == 0) {

				tableModel.setValueAt(null, i, column);								
			}
		}	
	}


	// * synchronized ist wichtig!!! Weil wenn man im Header eine Sortierung aktiviert... die Icons in der Tabelle nicht mehr angezeigt werden! *
	synchronized public void setDirectoryDesign() {

		try { 

			// * Wenn das Verzeichnis neu geladen wurde, dann Clicked Row Name loeschen, damit beim Click auf das selbe Row gleich der Row Editor gestartet wird! *


			final RowSorter sorter = getRowSorter();
			final List sortKeys = new ArrayList();			

			doSortingTable(oldSelectedHeaderColumn, sorter, sortKeys, false);




			// * Spaltenbreite *

			TableColumnModel tcm = getColumnModel();
			if(tcm.getColumnCount() == 0) return;

			TableColumn column = null;
			for (int i = 0; i < directory.columnNames.length; i++) {

				column = tcm.getColumn(i);
				column.setCellRenderer(new ColoredTableCellRenderer());

				// * Icon Size *
				if (i == 0) 	{
					column.setMinWidth(directory.directoryIconRowWidth); // 5 Pixel Abstand, damit nicht so gequetscht am linken Rand!
					column.setMaxWidth(directory.directoryIconRowWidth); // 5 Pixel Abstand, damit nicht so gequetscht am linken Rand!
				}
				else if (i == 1) 	column.setMinWidth(directory.directoryNameRowMinWidth);
				else if (i == 2) 	{
					column.setMinWidth(directory.directorySizeRowWidth); 
					column.setMaxWidth(directory.directorySizeRowWidth); 
				}
				else if (i == 3) 	{
					column.setMinWidth(directory.directoryModifiedRowWidth); 
					column.setMaxWidth(directory.directoryModifiedRowWidth); 
				}
				else if (i == 4) 	{

					column.setMinWidth(directory.directoryPermissionsRowWidth); 
					column.setMaxWidth(directory.directoryPermissionsRowWidth); 
				}
				else 	column.setPreferredWidth(directory.directoryLastRowWidth);     
			}

		}
		catch(Exception e) {e.printStackTrace();}

	}



	class StringComparator implements Comparator<String> {

		SortOrder sortOrder;
		StringComparator(SortOrder sortOrder) {

			this.sortOrder = sortOrder;
		}

		public int compare(String s1, String s2) {

			// * Case insensitive *
			s1 = s1.toLowerCase();
			s2 = s2.toLowerCase();

			if (s1.compareTo(s2) == 0) { // same string 

				return s1.compareTo(s2); 
			} 
			else {

				if (s1.trim().equals("") && !s2.trim().equals("")) {
					return s2.compareTo(s1);
				}    

				else if (!s1.trim().equals("") && s2.trim().equals("")) {
					return s1.compareTo(s2);
				}   
				else {
					return s1.compareTo(s2);
				}                 
			}
		}
	}

	class FileDateComparator implements Comparator<String> {

		SortOrder sortOrder;
		FileDateComparator(SortOrder sortOrder) {

			this.sortOrder = sortOrder;
		}

		public int compare(String s1, String s2) {

			// * Case insensitive *
			s1 = s1.toLowerCase();
			s2 = s2.toLowerCase();


			// * for sorting: new string compositing ...  "Year.Month.Day Time" *

			try {

				String[] dateSplit1 = s1.trim().split("\\.| ");
				String[] dateSplit2 = s2.trim().split("\\.| ");

				// * Wenn fuer das Sortieren "zzzzzz" fuer Lerzeilen eingefuegt wurden, dann Fehler abfangen! *
				if(dateSplit1.length == 4 && dateSplit2.length == 4) {

					s1 = dateSplit1[2] + "." + dateSplit1[1] + "." + dateSplit1[0] + " " + dateSplit1[3];
					s2 = dateSplit2[2] + "." + dateSplit2[1] + "." + dateSplit2[0] + " " + dateSplit2[3];
				}
			}
			catch(Exception e) {e.printStackTrace();}

			if (s1.compareTo(s2) == 0) { // same string 

				return s1.compareTo(s2); 
			} 
			else {

				if (s1.trim().equals("") && !s2.trim().equals("")) {
					return s2.compareTo(s1);
				}    

				else if (!s1.trim().equals("") && s2.trim().equals("")) {
					return s1.compareTo(s2);
				}   
				else {
					return s1.compareTo(s2);
				}                 
			}
		}
	}

	class FileSizeComparator implements Comparator<String> {

		SortOrder sortOrder;
		FileSizeComparator(SortOrder sortOrder) {
			this.sortOrder = sortOrder;
		}

		public int compare(String s1, String s2) {

			// * Case insensitive *
			s1 = s1.toLowerCase();
			s2 = s2.toLowerCase();

			// * Convert Strings to String Numbers in Bytes *
			s1 = Functions.convertToFlatBytes(s1);
			s2 = Functions.convertToFlatBytes(s2);

			if (s1.compareTo(s2) == 0) { // same string 
				return s1.compareTo(s2); 
			} 
			else {

				if (s1.trim().equals("") && !s2.trim().equals("")) { 
					return s2.compareTo(s1);
				}    
				else if (!s1.trim().equals("") && s2.trim().equals("")) {
					return s1.compareTo(s2);
				}   
				else {
					return s1.compareTo(s2);
				}                 
			}
		}
	}


	boolean theWholeRow = false;

	class ColoredTableCellRenderer extends DefaultTableCellRenderer {

		JImage label = new JImage(); {

			label.setVerticalTextPosition(JLabel.CENTER);
			label.setHorizontalTextPosition(JLabel.CENTER);
			label.setFont(directory.directoryTableFont);
		}

		JLabel textField = new JLabel(); {

			textField.setVerticalTextPosition(JLabel.CENTER);
			textField.setHorizontalTextPosition(JLabel.LEFT);	
			textField.setFont(directory.directoryTableFont);
		}


		public Component getTableCellRendererComponent(JTable table, Object value, boolean selected, boolean focused, int row, int column)	{
			super.getTableCellRendererComponent(table, value, selected, focused, row, column);

			// * Blauen Rahmen bei leeren Zellen deaktivieren (null) *
			setBorder (null);

			if(selected && value == null) table.clearSelection();


			// * Abwechselnde Farben *
			if ((row % 2) == 0)	setBackground(new Color(0xf5f5f5));
			else					setBackground(new Color(0xffffff));


			// * Wenn Cell = null, dann nicht weiter verarbeiten *
			if(value == null) return this;

			if(column == 0) theWholeRow = false;
			if( value instanceof ImageIcon ) {

				label.drawLink(false);

				boolean symbolLink = false;
				try {

					String s = directory.directoryPath + (String)directoryTable.getValueAt(row,1);
					if(Functions.isLinkFile(new File(s)) != null)  symbolLink = true;
				}
				catch(Exception e) {e.printStackTrace();}

				if(!symbolLink) {
					label.setIcon((ImageIcon) value);
				}
				else {
					label.setIcon((ImageIcon) value);
					label.drawLink(true);
				}

				label.setImageHeight(directory.directoryIconWidth);
				label.setImageWidth(directory.directoryIconWidth);

				label.setText("");
				Color c = new Color(0xffffff);

				if ((row % 2) == 0)	c = new Color(0xf5f5f5);
				else					c = new Color(0xffffff);

				if(selected) {

					if(value != null) c = new Color(0x4169d9);	
					textField.setForeground(new Color(0xffffff));
				}
				else textField.setForeground(new Color(0x000000));

				label.setOpaque(true);
				label.setBackground(c); // *  Table Row Color if selected *


				return label;
			}


			if( value instanceof String) {

				if(column == 0) theWholeRow = false;
				if(column == 1 && value.toString().startsWith(".")) theWholeRow = true;

				textField.setForeground(new Color(0,0,0,255));

				if(theWholeRow == false) {

					if(column > 1) textField.setForeground(new Color(0,0,0));						
				}
				else textField.setForeground(new Color(0,0,0));


				if(column == 2) textField.setHorizontalAlignment(JTextField.RIGHT);

				textField.setText("" + value + "   ");
				textField.setIcon(null);

				Color c = new Color(0xffffff);
				if ((row % 2) == 0)	c = new Color(0xf5f5f5);
				else					c = new Color(0xffffff);

				if(selected) {

					// * Wenn selektiert, dann Hintergrund Blau *
					if(value != null) c = new Color(0x4169d9);	 // *  Table Row Color if selected *
					textField.setForeground(new Color(0xffffff));

				}

				textField.setOpaque(true);
				textField.setBackground(c);


				return textField;
			}
			return this;
		}
	}

	// * JTable Header *
	public class TableHeaderRenderer extends JComponent implements TableCellRenderer {

		private final TableCellRenderer baseRenderer;

		JComponent compoment;

		public TableHeaderRenderer(TableCellRenderer baseRenderer) {
			this.baseRenderer = baseRenderer;			
		}

		// * Trennlinie zwischen Table Header und Liste *
		@Override
		public JComponent getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
			JComponent c = (JComponent)baseRenderer.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);

			// * Flat Header Table Border *
			c.setBorder(BorderFactory.createLineBorder(new Color(220,220,220,150)));
			c.setBackground(new Color(240,240,240));

			return c;
		}				
	}
}
