package ffilechooser;


import java.awt.AWTEvent;
import java.awt.ActiveEvent;
import java.awt.Color;
import java.awt.Component;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.EventQueue;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.MenuComponent;
import java.awt.Toolkit;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.InputStream;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Vector;
import java.util.prefs.Preferences;
import java.util.stream.Collectors;

import javax.imageio.ImageIO;
import javax.swing.BorderFactory;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JLayeredPane;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;
import javax.swing.SortOrder;
import javax.swing.SwingUtilities;


public class FFileChooser {

	private int rW(float v) 		{ return (int)(fframe.monitor.convertFloatToRealWidth(v)); }
	private int rH(float v) 		{ return (int)(fframe.monitor.convertFloatToRealHeight(v)); }
	private float fW(int v) 		{ return (float)(fframe.monitor.convertRealToFloatWidth(v)); }
	private float fH(int v) 		{ return (float)(fframe.monitor.convertRealToFloatHeight(v)); }

	public String directoryTableHeaderFontName 		= "Dialog";
	public int directoryTableHeaderFontType 			= Font.PLAIN;
	public float directoryTableHeaderFontSize 		= 0.01f;

	public String directoryTableFontName 			= "Dialog";
	public int directoryTableFontType 				= Font.PLAIN;
	public float directoryTableFontSize 				= 0.01f;

	public String drivesPanelCategoryFontBoldName 	= "Dialog";
	public int drivesPanelCategoryFontBoldType 		= Font.BOLD;
	public float drivesPanelCategoryFontBoldSize 	= 0.01f;

	public String drivesPanelFontName 				= "Dialog";
	public int drivesPanelFontType 					= Font.PLAIN;
	public float drivesPanelFontSize 				= 0.01f;

	public String drivesPanelFontBoldName 			= "Dialog";
	public int drivesPanelFontBoldType 				= Font.BOLD;
	public float drivesPanelFontBoldSize 			= 0.01f;



	final static String PREF_NAME_load_filepath 			= "load_path3";
	final static String PREF_NAME_load_selected_file 	= "load_file3";
	final static String PREF_NAME_save_filepath 			= "save_path3";
	final static String PREF_NAME_save_selected_file 	= "save_file3";


	Preferences prefs;


	FFileChooser ffileChooser;	
	public FFrame fframe;

	JLayeredPane layeredPane;

	Directory directoryFrame;
	public LeftPanel leftFrame;
	JLayeredPane topFrame;
	JLayeredPane bottomFrame;



	float topFrameX; 
	float topFrameY; 
	float topFrameWidth; 
	float topFrameHeight; 

	float bottomFrameX; 
	float bottomFrameY; 
	float bottomFrameWidth; 
	float bottomFrameHeight; 

	float diskFrameX; 
	float diskFrameY ; 
	float diskFrameWidth; 
	float diskFrameHeight; 


	float directoryFrameX; 
	float directoryFrameY; 
	float directoryFrameWidth; 
	float directoryFrameHeight; 



	static public final int TYPE_LOAD = 0;  
	static public final int TYPE_SAVE = 1;  

	private int type = TYPE_LOAD;



	BufferedImage back;
	BufferedImage backOff;
	BufferedImage forward;
	BufferedImage forwardOff;

	FButton forwardButton;
	FButton backButton;

	FButton buttonNewFolder;
	FButton buttonLoad;
	FButton buttonCancel;

	FLabel labelLoad;
	FLabel labelSave;
	FTextField textfieldLoad;
	FTextField textfieldSave;

	FImage topDirImage;
	FLabel topDirLabel;

	Font font;
	Font fontLight;
	Font fontTextField;

	final JFileChooser fc = new JFileChooser(); // *  fuer Icons *


	File selectedFile = null;

	int event = 0;

	Vector<File> history = new Vector<File>();
	int historyPointer = -1;


	boolean oldStyle = false;

	public FFileChooser(Class myClass, String title, int type, boolean oldStyle) {

		ffileChooser 	= this;
		this.type 		= type;
		this.oldStyle 	= oldStyle;

		String [] favorites = getFavoritesNames().values().toArray(new String[0]);

		prefs = Preferences.userRoot().node(myClass.getName());


		fframe = new FFrame(new FFrameListener() {

			@Override
			public void monitorResolutionChanged() {				
				ffileChooser.monitorResolutionChanged();
			}

			@Override
			public void frameResized() {
				ffileChooser.frameResized();

			}

			@Override
			public void frameMoved() {
				//ffileChooser.frameMoved();				
			}
		});

		fframe.addWindowListener(new WindowAdapter()	{
			public void windowClosing(WindowEvent e) {

				//ffileChooser.quit();		
			}
		});


		fframe.setTitle(title);
		fframe.setUndecorated(false);
		fframe.setLayout(null);
		fframe.setBackground(new Color(239,239,239));
		fframe.setFocusable(true);
		fframe.setResizable(true);				
		fframe.setAlwaysOnTop(true);



		if(oldStyle) {

			font 			= new Font("Commodore 64", Font.PLAIN, rH(0.007f));		
			fontLight 		= new Font("Commodore 64", Font.PLAIN, rH(0.007f));		
			fontTextField 	= new Font("Commodore 64", Font.PLAIN, rH(0.008f));	


			directoryTableHeaderFontName = "Commodore 64";
			directoryTableHeaderFontType = Font.PLAIN;
			directoryTableHeaderFontSize = fH(9);

			directoryTableFontName = "Commodore 64";
			directoryTableFontType = Font.PLAIN;
			directoryTableFontSize = fH(10);

			drivesPanelCategoryFontBoldName = "Commodore 64";
			drivesPanelCategoryFontBoldType = Font.BOLD;
			drivesPanelCategoryFontBoldSize = fH(8);

			drivesPanelFontName = "Commodore 64";
			drivesPanelFontType = Font.PLAIN;
			drivesPanelFontSize =fH(10);

			drivesPanelFontBoldName = "Commodore 64";
			drivesPanelFontBoldType = Font.BOLD;
			drivesPanelFontBoldSize = fH(10);

		}
		else {

			font 			= new Font("Dialog", Font.PLAIN, rH(0.010f));		
			fontLight 		= new Font("Dialog", Font.PLAIN, rH(0.010f));		
			fontTextField 	= new Font("Dialog", Font.PLAIN, rH(0.011f));		

			directoryTableHeaderFontName = "Dialog";
			directoryTableHeaderFontType = Font.BOLD;
			directoryTableHeaderFontSize = 0.008333334f;
			
			directoryTableFontName = "Dialog";
			directoryTableFontType = Font.PLAIN;
			directoryTableFontSize = 0.010416667f;

			drivesPanelCategoryFontBoldName = "Dialog";
			drivesPanelCategoryFontBoldType = Font.BOLD;
			drivesPanelCategoryFontBoldSize = 0.008333334f;

			drivesPanelFontName = "Dialog";
			drivesPanelFontType = Font.PLAIN;
			drivesPanelFontSize = 0.009722223f;

			drivesPanelFontBoldName = "Dialog";
			drivesPanelFontBoldType = Font.BOLD;
			drivesPanelFontBoldSize = 0.009722223f;						

		}


		try	{ 

			InputStream in = ClassLoader.class.getResourceAsStream("/ffileshooser_pack/back.png");
			back = ImageIO.read(in);

			in = ClassLoader.class.getResourceAsStream("/ffileshooser_pack/back_off.png");
			backOff = ImageIO.read(in);

			in = ClassLoader.class.getResourceAsStream("/ffileshooser_pack/forward.png");
			forward = ImageIO.read(in);

			in = ClassLoader.class.getResourceAsStream("/ffileshooser_pack/forward_off.png");
			forwardOff = ImageIO.read(in);			
		} 
		catch( Exception e ) { e.printStackTrace();	}


		topFrame  		= new JLayeredPane();
		bottomFrame 		= new JLayeredPane();
		directoryFrame 	= new Directory(fframe, favorites, this);
		leftFrame 		= new LeftPanel(directoryFrame);

		topFrame.setBackground(new Color(239,239,239));
		bottomFrame.setBackground(new Color(239,239,239));
		directoryFrame.setBackground(new Color(239,239,239));
		leftFrame.setBackground(new Color(239,239,239));


		directoryFrame.setBorder(BorderFactory.createLineBorder(Color.LIGHT_GRAY,fframe.monitor.convertFloatToRealHeight(0.0010f)));
		leftFrame.setBorder(BorderFactory.createLineBorder(Color.LIGHT_GRAY,fframe.monitor.convertFloatToRealHeight(0.0010f)));

		layeredPane = new JLayeredPane();

		layeredPane.add(topFrame);
		layeredPane.add(bottomFrame);
		layeredPane.add(leftFrame);
		layeredPane.add(directoryFrame);


		topDirImage = new FImage(fframe);
		topDirImage.setImage(back);
		topDirImage.setBounds(0.1f, 0.013f, 0.012f, 0.018f);		
		topFrame.add(topDirImage);

		topDirLabel = new FLabel(fframe);		
		topDirLabel.setFont(fontLight);
		topDirLabel.setText("Applications");
		topDirLabel.setBounds(0.13f, 0.013f, 0.1f, 0.018f);
		topFrame.add(topDirLabel);



		backButton = new FButton(fframe);
		backButton.setImage(backOff);		
		backButton.setBorderColor(new Color(197,197,197,255));
		backButton.addMouseListener(new MouseListener() {
			@Override
			public void mouseClicked(MouseEvent e) {}
			@Override
			public void mousePressed(MouseEvent e) {	
				back();
			}
			@Override
			public void mouseReleased(MouseEvent e) {}
			@Override
			public void mouseEntered(MouseEvent e) {}
			@Override
			public void mouseExited(MouseEvent e) {}				
		});
		layeredPane.add(backButton);

		forwardButton = new FButton(fframe);
		forwardButton.setImage(forwardOff);		
		forwardButton.setBorderColor(new Color(197,197,197,255));
		forwardButton.addMouseListener(new MouseListener() {
			@Override
			public void mouseClicked(MouseEvent e) {}
			@Override
			public void mousePressed(MouseEvent e) {	
				forward();
			}
			@Override
			public void mouseReleased(MouseEvent e) {}
			@Override
			public void mouseEntered(MouseEvent e) {}
			@Override
			public void mouseExited(MouseEvent e) {}				
		});
		layeredPane.add(forwardButton);


		if(type == TYPE_LOAD) {

			labelLoad = new FLabel(fframe);
			labelLoad.setText("File:");
			labelLoad.setFont(fontTextField);
			labelLoad.setFontColor(Color.DARK_GRAY);			
			labelLoad.setBounds(0.090f, 0.0162f, 0.030f, 0.024f);
			labelLoad.setEnabled(true);	

			bottomFrame.add(labelLoad);

			textfieldLoad = new FTextField(fframe);
			textfieldLoad.setText("");
			textfieldLoad.setFont(fontTextField);
			textfieldLoad.setForeground(Color.BLACK);
			textfieldLoad.setDisabledTextColor(Color.BLACK);
			textfieldLoad.setBounds(0.105f, 0.0162f, 0.130f, 0.024f);
			textfieldLoad.setEnabled(false);			
			bottomFrame.add(textfieldLoad);


			buttonCancel = new FButton(fframe);
			buttonCancel.setText("Cancel");
			buttonCancel.setFont(fontLight);
			buttonCancel.setBounds(0.278f, 0.015f, 0.030f, 0.020f);
			buttonCancel.setEnabled(true);
			buttonCancel.addMouseListener(new MouseListener() {
				@Override
				public void mouseClicked(MouseEvent e) {}
				@Override
				public void mousePressed(MouseEvent e) {	
					event = 0;
					fframe.dispose();
				}
				@Override
				public void mouseReleased(MouseEvent e) {}
				@Override
				public void mouseEntered(MouseEvent e) {}
				@Override
				public void mouseExited(MouseEvent e) {}				
			});
			bottomFrame.add(buttonCancel);


			buttonLoad = new FButton(fframe);
			buttonLoad.setText("Load");
			buttonLoad.setFont(fontLight);
			buttonLoad.setBounds(0.312f, 0.015f, 0.030f, 0.020f);
			buttonLoad.setEnabled(true);
			buttonLoad.addMouseListener(new MouseListener() {
				@Override
				public void mouseClicked(MouseEvent e) {}

				@Override
				public void mousePressed(MouseEvent e) {																
					event = 1;
					fframe.dispose();
				}
				@Override
				public void mouseReleased(MouseEvent e) {}
				@Override
				public void mouseEntered(MouseEvent e) {}
				@Override
				public void mouseExited(MouseEvent e) {}


			});
			bottomFrame.add(buttonLoad);
		}

		if(type == TYPE_SAVE) {


			buttonNewFolder = new FButton(fframe);
			buttonNewFolder.setText("New Folder");
			buttonNewFolder.setFont(fontLight);
			buttonNewFolder.setBounds(0.008f, 0.015f, 0.040f, 0.020f);
			buttonNewFolder.setEnabled(true);
			buttonNewFolder.addMouseListener(new MouseListener() {
				@Override
				public void mouseClicked(MouseEvent e) {}
				@Override
				public void mousePressed(MouseEvent e) {
					//event = 0;
					//fframe.dispose();

					newFolder();
				}
				@Override
				public void mouseReleased(MouseEvent e) {}
				@Override
				public void mouseEntered(MouseEvent e) {}
				@Override
				public void mouseExited(MouseEvent e) {}				
			});
			bottomFrame.add(buttonNewFolder);


			labelSave = new FLabel(fframe);
			labelSave.setText("File:");
			labelSave.setFont(fontTextField);
			labelSave.setFontColor(Color.DARK_GRAY);			
			labelSave.setBounds(0.090f, 0.017f, 0.030f, 0.024f);
			labelSave.setEnabled(true);	

			bottomFrame.add(labelSave);

			textfieldSave = new FTextField(fframe);
			textfieldSave.setText("");
			textfieldSave.setFont(fontTextField);
			textfieldSave.setForeground(Color.BLACK);			
			textfieldSave.setBounds(0.105f, 0.017f, 0.130f, 0.024f);
			textfieldSave.setEnabled(true);			
			bottomFrame.add(textfieldSave);


			buttonCancel = new FButton(fframe);
			buttonCancel.setText("Cancel");
			buttonCancel.setFont(fontLight);
			buttonCancel.setBounds(0.278f, 0.015f, 0.030f, 0.020f);
			buttonCancel.setEnabled(true);
			buttonCancel.addMouseListener(new MouseListener() {
				@Override
				public void mouseClicked(MouseEvent e) {}
				@Override
				public void mousePressed(MouseEvent e) {
					event = 0;
					fframe.dispose();
				}
				@Override
				public void mouseReleased(MouseEvent e) {}
				@Override
				public void mouseEntered(MouseEvent e) {}
				@Override
				public void mouseExited(MouseEvent e) {}				
			});
			bottomFrame.add(buttonCancel);


			buttonLoad = new FButton(fframe);
			buttonLoad.setText("Save");
			buttonLoad.setFont(fontLight);
			buttonLoad.setBounds(0.312f, 0.015f, 0.030f, 0.020f);
			buttonLoad.setEnabled(true);
			buttonLoad.addMouseListener(new MouseListener() {

				@Override
				public void mouseClicked(MouseEvent e) {}

				@Override
				public void mousePressed(MouseEvent e) {	
					event = 1;
					fframe.dispose();
				}
				@Override
				public void mouseReleased(MouseEvent e) {}
				@Override
				public void mouseEntered(MouseEvent e) {}
				@Override
				public void mouseExited(MouseEvent e) {}


			});
			bottomFrame.add(buttonLoad);			
		}	

		
		sortAndSelect();
		
		updateBackForwardButtons();
	}
	
	public void sortAndSelect() {
		
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				try {

					setCurrentDirectory(new File(getPath())); 	


					if(directoryFrame.directoryTable.getSavedOrder() == SortOrder.DESCENDING) {

						directoryFrame.directoryTable.columnEvent(directoryFrame.directoryTable.getSavedCloumn());
						directoryFrame.directoryTable.columnEvent(directoryFrame.directoryTable.getSavedCloumn());
					}

					Thread T=new Thread(new Runnable() {

						@Override
						public void run() {

							try {

								Thread.sleep(500);

								SwingUtilities.invokeLater(new Runnable() {
									public void run() {
										try {

											selectRow(getFile());	
										}
										catch(Exception e) {}
									}});
							}
							catch(Exception e) {e.printStackTrace();}
						}
					} );
					T.start();	
				}
				catch(Exception e) {}
			}});
	}
	
	

	public void setTableHeaderFont(String fontName) {

		directoryTableHeaderFontName 	= fontName;
		directoryTableHeaderFontType 	= Font.PLAIN;
	}

	public void setDirectoryTableFont(String fontName, int size) {

		directoryTableFontName 			= fontName;
		directoryTableFontType 			= Font.PLAIN;
	}

	public void setDrivesPanelCategoryBoldFont(String fontName, float size) {

		drivesPanelCategoryFontBoldName 	= fontName;
		drivesPanelCategoryFontBoldType 	= Font.BOLD;
	}

	public void setDrivesPanelFont(String fontName, float size) {

		drivesPanelFontName 				= fontName;
		drivesPanelFontType 				= Font.PLAIN;
	}

	public void setdrivesPanelBoldFont(String font, float size) {

		drivesPanelFontBoldName 			= font;
		drivesPanelFontBoldType 			= Font.BOLD;
	}


	public void setCurrentDirectory(File file) {		

		directoryFrame.loadDirectory(file.getAbsolutePath(), false);	
	}

	public void selectRow(String fileName) {

		directoryFrame.selectRow(fileName);
	}


	private void newFolder() { 

		Dimension d = Toolkit.getDefaultToolkit().getScreenSize();

		
		String[] options = new String[]{ "Create", "Cancel" };
		final JOptionPane optionPane = new JOptionPane();
		
		final JDialog dialog = optionPane.createDialog(fframe, "New Folder");
				
		
		JPanel panel = new JPanel();	
		JLabel label = new JLabel("Folder name:");
		final JTextField folder = new JTextField(10);
		folder.addKeyListener(new KeyListener() {

			@Override
			public void keyTyped(KeyEvent e) {}

			@Override
			public void keyPressed(KeyEvent e) {
				
				if(e.getKeyCode() == 10) {
					
					String folderName = folder.getText().trim();
					if(folderName.length() > 0) createNewFolderinSelectedDir(folderName);
					dialog.dispose();
				}
			}

			@Override
			public void keyReleased(KeyEvent e) {}			
		});

		panel.add(label);
		panel.add(folder);


		final Runnable r = new Runnable() {
			public void run() {

				// * 4 x because at the very first start it needs ~ 1,5 seconds, then only 0.2 Seconds *

				try { Thread.sleep(500); } catch (InterruptedException e) {	e.printStackTrace();	}		        	
				folder.requestFocus();

				try { Thread.sleep(500); } catch (InterruptedException e) {	e.printStackTrace();	}		        	
				folder.requestFocus();

				try { Thread.sleep(500); } catch (InterruptedException e) {	e.printStackTrace();	}		        	
				folder.requestFocus();

				try { Thread.sleep(500); } catch (InterruptedException e) {	e.printStackTrace();	}		        	
				folder.requestFocus();
			}
		};
		new Thread(r).start();

		optionPane.setFocusable(true);
		optionPane.setMessage(panel);
		optionPane.setOptionType(JOptionPane.NO_OPTION);
		optionPane.setMessageType(JOptionPane.PLAIN_MESSAGE);
		optionPane.setIcon(null);
		optionPane.setOptions(options);
		optionPane.requestFocus();

		dialog.setSize(300, 130);
		dialog.setBounds(d.width/2-150, d.height/2-65, 300, 130);
		dialog.toFront();
		dialog.setAlwaysOnTop(true);
		dialog.pack();	
		//dialog.setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);		
		dialog.setVisible(true);

		dialog.requestFocus();

		String result = (String) optionPane.getValue();				
		if(result != null && result.contains("Create")) { // pressing OK button

			String folderName = folder.getText().trim();
			if(folderName.length() > 0) createNewFolderinSelectedDir(folderName);
		}

		dialog.dispose();
	}


	private void createNewFolderinSelectedDir(String folderName) {
		
		try {
			
			new File(directoryFrame.directory.directoryPath + "/" + folderName).mkdir();
			
			setCurrentDirectory(new File(directoryFrame.directory.directoryPath + "/" + folderName)); 
			sortAndSelect();					
		}
		catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	

	File lastFile = null;

	public void addToHistory(File file) {

		if(file.isDirectory()) {

			if(!file.equals(lastFile)) {

				if(historyPointer != -1) {

					int delCount = history.size()-(historyPointer+1);					
					for(int i=0;i<delCount;i++) history.removeElementAt(history.size()-1);
				}

				historyPointer = -1;

				history.add(file);
				lastFile = file;


				updateBackForwardButtons();
			}
		}
	}



	public void doubleClickedFile() {

		event = 1;
		fframe.dispose();
	}

	public void setSelectedFile(File file) {	

		if(file.isDirectory()) 		putPath(file.getAbsolutePath());		

		if(new File(file.getParent() + "/" + file.getName()).isFile()) 	{

			putFile(file.getName());
			if(new File(file.getParent()).isDirectory()) putPath(file.getParent());		

			if(type == TYPE_LOAD) {

				textfieldLoad.setText(file.getName());
			}
			else {
				textfieldSave.setText(file.getName());
			}			
		}

		this.selectedFile = file;	
	}
	
	public void setSaveTextField(String name) {		
		textfieldSave.setText(name);
	}

	public String getSaveTextField() {
		return textfieldSave.getText();
	}
	

	public File getSelectedFile() {	

		if(type == TYPE_LOAD) {

			return selectedFile;
		}
		else {
			return new File(getPath() + "/" + textfieldSave.getText().trim());
		}
	}

	private void back() {


		if(historyPointer == -1) {

			if(directoryFrame.directoryPath.compareTo("/Volumes") != 0 && directoryFrame.directoryPath.compareTo("/") != 0) {

				String parentPath = new File(directoryFrame.directoryPath).getParent();
				directoryFrame.loadDirectory(parentPath, false);
			}
			return;
		}
		
		if(historyPointer > 0 || historyPointer == -1) {

			if(historyPointer == -1) {

				historyPointer = history.size()-2;
				if(historyPointer < 0) historyPointer = 0;
			}
			else 						historyPointer--;

			if(historyPointer >= 0) {

				directoryFrame.loadDirectory(history.elementAt(historyPointer).getAbsolutePath(), false);
				leftFrame.highlightListItemFromPath(history.elementAt(historyPointer).getAbsolutePath());				
			}


			if(historyPointer == 0) 	backButton.setImage(backOff);
			else						backButton.setImage(back);			
		}		

		updateBackForwardButtons();
	}

	private void forward() {

		if(historyPointer < history.size()-1) {

			historyPointer++;
			directoryFrame.loadDirectory(history.elementAt(historyPointer).getAbsolutePath(), false);
			leftFrame.highlightListItemFromPath(history.elementAt(historyPointer).getAbsolutePath());

		}

		updateBackForwardButtons();
	}

	private void updateBackForwardButtons() {

		if(historyPointer == 0 && directoryFrame.directoryPath.compareTo("/") == 0) 	backButton.setImage(backOff);
		else																			backButton.setImage(back);	

		if(historyPointer < history.size()-1 && historyPointer != -1) 	forwardButton.setImage(forward);
		else																forwardButton.setImage(forwardOff);
	}



	public void topFrameUpdateDirectoryName(String path) {

		String name = new File(path).getName();	

		topDirLabel.setText(name);

		try {

			BufferedImage image = null;

			Icon icon = fc.getUI().getFileView(fc).getIcon(new File(path));					
			image = new BufferedImage(icon.getIconWidth(), icon.getIconHeight(), 2);
			Graphics g = image.getGraphics();
			icon.paintIcon(null, g, 0, 0);
			g.dispose();

			if(image != null) topDirImage.setImage(image);
		}
		catch(Exception e) {	
			e.printStackTrace();
		}

		updateBounds();
	}


	public int show() {

		selectedFile = null;

		directoryFrame.reloadDir();		

		fframe.setContentPane(layeredPane);
		fframe.setVisible(true);

		update();


		// * Block the Main Thread, but let the GUI Thread going! *

		EventQueue queue = Toolkit.getDefaultToolkit().getSystemEventQueue();
		try	{
			while (fframe.isShowing()) {

				if (EventQueue.isDispatchThread()) {

					AWTEvent ev = queue.getNextEvent();
					if (ev instanceof ActiveEvent)						((ActiveEvent) ev).dispatch();
					else if (ev.getSource() instanceof Component)		((Component) ev.getSource()).dispatchEvent(ev);
					else if (ev.getSource() instanceof MenuComponent)	((MenuComponent) ev.getSource()).dispatchEvent(ev);					
				}
				else Thread.yield(); // Give other threads a chance to become active.		
			}
		}
		catch (InterruptedException ex)	{

		}

		return event;
	}

	private void update() {

		// * If the Image is bigger than the frame, then center the bars in the middle *
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				try {

					//monitorResolutionChanged();
					updateBounds();

				}
				catch(Exception e) {}
			}});
	}





	private void putPath(String path) {

		if(type == TYPE_LOAD) 	prefs.put(PREF_NAME_load_filepath, path);
		else 					prefs.put(PREF_NAME_save_filepath, path);

	}

	private void putFile(String filename) {

		if(type == TYPE_LOAD) 	prefs.put(PREF_NAME_load_selected_file, filename);
		else 					prefs.put(PREF_NAME_save_selected_file, filename);

	}

	private String getPath() {

		String path = "";

		if(type == TYPE_LOAD) 	path = prefs.get(PREF_NAME_load_filepath, "/Volumes");
		else 					path = prefs.get(PREF_NAME_save_filepath, "/Volumes");

		return path;
	}

	private String getFile() {

		String filename = "";

		if(type == TYPE_LOAD) 	filename = prefs.get(PREF_NAME_load_selected_file, "");
		else 					filename = prefs.get(PREF_NAME_save_selected_file, "");

		return filename;
	}




	private void monitorResolutionChanged() {

		directoryFrame.updateUI();
		updateBounds();
	}

	private void frameResized() {
		updateBounds();
	}


	public void setBounds(float x, float y, float width, float height) {

		fframe.setBounds(x,y,width, height);
	}

	public void setMinimumSize(float width, float height) {

		fframe.setMinimumSize(width, height);		
	}


	private void updateBounds() {
		
		
		topFrameWidth 			= fW(rW(fframe.width));
		bottomFrameWidth			= topFrameWidth;

		topFrameHeight 			= 0.038f;
		bottomFrameHeight 		= 0.065f;
		directoryFrameHeight	 	= fframe.height - fW(rW(topFrameHeight + bottomFrameHeight));
		diskFrameHeight			= directoryFrameHeight;

		topFrameX 				= 0; 
		topFrameY 				= 0; 

		bottomFrameX 			= 0; 
		bottomFrameY 			= topFrameHeight+diskFrameHeight;

		diskFrameX 				= 0; 
		diskFrameY 				= topFrameHeight; 
		diskFrameWidth 			= 0.09f;
		diskFrameHeight 			= fframe.height-topFrameHeight-bottomFrameHeight; 

		directoryFrameX 			= diskFrameWidth; 
		directoryFrameY 			= topFrameHeight; 
		directoryFrameWidth 		= fframe.width-diskFrameWidth+0.001f; 
		directoryFrameHeight 	= fframe.height-topFrameHeight-bottomFrameHeight; 


		topFrame.setBounds(rW(topFrameX),rH(topFrameY), rW(topFrameWidth),rH(topFrameHeight));
		bottomFrame.setBounds(rW(bottomFrameX),rH(bottomFrameY), rW(bottomFrameWidth),rH(bottomFrameHeight));
		leftFrame.setBounds(rW(diskFrameX),rH(diskFrameY), rW(diskFrameWidth),rH(diskFrameHeight));
		directoryFrame.setBounds(rW(directoryFrameX),rH(directoryFrameY), rW(directoryFrameWidth),rH(directoryFrameHeight));


		leftFrame.jList.setFixedCellHeight(leftFrame.directory.drivesPanelCellHeight);

		backButton.setBounds(0.0030f, 0.011f, 0.012f, 0.018f);
		forwardButton.setBounds(0.0135f, 0.011f, 0.012f, 0.018f);


		if(type == TYPE_LOAD || type == TYPE_SAVE) {

			float cancelLoadX = directoryFrameWidth + 0.016f;						
			buttonCancel.setBounds(cancelLoadX, 0.015f, 0.030f, 0.020f);
			buttonLoad.setBounds(cancelLoadX + 0.034f, 0.015f, 0.030f, 0.020f);		


			FontMetrics fm =  fframe.getFontMetrics(font);
			int width = fm.stringWidth(topDirLabel.getText());			
			topDirLabel.setSize(fW(width), fH(fm.getHeight()));

			float dirNameX = 0.035f + directoryFrameWidth/2 - topDirLabel.width/2;						
			topDirImage.setBounds(dirNameX, 0.014f, 0.008f, 0.012f);		
			topDirLabel.setBounds(dirNameX + 0.012f, 0.013f, 0.1f, 0.018f);		


		}


	}




	// ************************************
	// ***                              ***
	// ***           Favorites          ***
	// ***                              ***
	// ************************************


	private Map<String,String> getFavoritesNames() {

		Map<String,String> list = new HashMap<String,String>();


		String f = "";

		try {

			String homeDir = System.getProperty("user.home");

			
		}
		catch(Exception e) {
			e.printStackTrace();
		}



		Map<String, String> result = list.entrySet().stream().sorted(Map.Entry.comparingByKey()).collect(Collectors.toMap(Map.Entry::getKey, Map.Entry::getValue, (oldValue, newValue) -> oldValue, LinkedHashMap::new));

		return result;

	}
}
