package ffilechooser;

import java.awt.AWTEvent;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.Toolkit;
import java.awt.event.AWTEventListener;
import java.awt.image.BufferedImage;

import javax.swing.JComponent;
import javax.swing.JFrame;

import ffilechooser.FMonitor.MonitorListener;

public class FImage extends JComponent {

	float x 			= 0;
	float y 			= 0;
	float width 		= 0.02f;
	float height 	= 0.02f;

	private BufferedImage image;
	private BufferedImage imageResized;

	
	float monitorOldWidth = 0;
	float monitorOldHeight = 0;
	
	
	FFrame fframe;
		
	public FImage(final FFrame fframe) {

		this.fframe = fframe;
				
		
		Toolkit.getDefaultToolkit().addAWTEventListener(new AWTEventListener() {

			@Override
			public void eventDispatched(AWTEvent event) {

				if(fframe.monitor.width != monitorOldWidth || fframe.monitor.height != monitorOldHeight) {

					monitorOldWidth = fframe.monitor.width;
					monitorOldHeight = fframe.monitor.height;
					updateImage();					
				}
			}
		}, AWTEvent.PAINT_EVENT_MASK);
	}


	private void updateImage() {
		updateBounds();
		resizeImage();
		repaint();		
	}
		
	public void setImage(BufferedImage image) {		
			
		this.image 	= image;
		updateImage();
	}
			
	public void setBounds(float x, float y, float width, float height) {

		this.x 		= x;
		this.y 		= y;
		this.width 	= width;
		this.height 	= height;	
		updateImage();
	}

	public void setLocation(float x, float y) {

		this.x 		= x;
		this.y 		= y;		
		updateImage();
	}

	public void setSize(float width, float height) {

		this.width 	= width;
		this.height 	= height;	
		updateImage();
	}
	
	private void updateBounds() {
				
		setBounds(fframe.monitor.convertFloatToRealWidth(x), fframe.monitor.convertFloatToRealHeight(y), fframe.monitor.convertFloatToRealWidth(width), fframe.monitor.convertFloatToRealHeight(height));
	}

	
	@Override
	protected void paintComponent(Graphics g) {		
		super.paintComponent(g);
						
		Graphics2D g2d = (Graphics2D)g;
		g2d.setRenderingHint(RenderingHints.KEY_ALPHA_INTERPOLATION, RenderingHints.VALUE_ALPHA_INTERPOLATION_QUALITY);
		g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		g2d.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BILINEAR);
				
		if(image != null) g2d.drawImage(imageResized, null,  0, 0);		
		g2d.dispose();		
	}
	
	
	private void resizeImage() {
		
		if(image != null)  imageResized = ImageTools.getScaledInstance(image, fframe.monitor.convertFloatToRealWidth(width), fframe.monitor.convertFloatToRealHeight(height), true);		
	}	
}
