package ffilechooser;

import java.awt.AWTEvent;
import java.awt.ActiveEvent;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.EventQueue;
import java.awt.MenuComponent;
import java.awt.Toolkit;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLayeredPane;


public class FPopupFrame implements Runnable {

	
	float x 			= 0;
	float y 			= 0;
	float width 		= 0.02f;
	float height 	= 0.02f;

	
	private Thread t;
	private boolean running = false;

	private JDialog frame;

	private JLayeredPane panel;
	
	
	FFrame fframe;
	
	public FPopupFrame(FFrame fframe) {
		
		this.fframe = fframe;
		
		panel = new JLayeredPane();	
		panel.setOpaque(true);
		
		frame  = new JDialog();
		frame.getContentPane().add(panel);
		frame.setAlwaysOnTop(true);
		frame.setResizable(false);
		
		frame.addWindowListener(new WindowAdapter()	{
			public void windowClosing(WindowEvent e) {
				dispose();	
			}
		});
	}
	
	public void add(JComponent comp) {		
		panel.add(comp);
	}
	
		
	public void setBackgroundColor(Color color) {
		frame.setBackground(color);		
		panel.setBackground(color);		
	}
	
	public void setBounds(float x, float y, float width, float height) {

		this.x 		= x;
		this.y 		= y;
		this.width 	= width;
		this.height 	= height;
		updateBounds();
	}

	public void setLocation(float x, float y) {

		this.x 		= x;
		this.y 		= y;		
		updateBounds();
	}

	public void setSize(float width, float height) {

		this.width 	= width;
		this.height 	= height;	
		updateBounds();
	}

	private void updateBounds() {

		frame.setBounds(fframe.monitor.convertFloatToRealWidth(x), fframe.monitor.convertFloatToRealHeight(y), fframe.monitor.convertFloatToRealWidth(width), fframe.monitor.convertFloatToRealHeight(height));
	}
	
	
	public void pack() {
		frame.pack();
	}


	public void setTitle(String title) {		
		frame.setTitle(title);
	}

	public void show() {

		frame.setVisible(true);

		
		// * Block the Main Thread, but let the GUI Thread going! *
		
		EventQueue queue = Toolkit.getDefaultToolkit().getSystemEventQueue();
		try	{
			while (frame.isShowing()) {
				
				if (EventQueue.isDispatchThread()) {
					
					AWTEvent ev = queue.getNextEvent();
					if (ev instanceof ActiveEvent)						((ActiveEvent) ev).dispatch();
					else if (ev.getSource() instanceof Component)		((Component) ev.getSource()).dispatchEvent(ev);
					else if (ev.getSource() instanceof MenuComponent)	((MenuComponent) ev.getSource()).dispatchEvent(ev);					
				}
				else Thread.yield(); // Give other threads a chance to become active.		
			}
		}
		catch (InterruptedException ex)	{
		}
		finally	{
		}
	}

	public void dispose() {

		running = false;
		frame.dispose();
	}

	public void run() {

		try {

			running = true;

			while(running) {Thread.sleep(100);}			
		} 
		catch (Exception e) {}		

		frame.dispose();
	}
}