package ffilechooser;

import java.awt.AlphaComposite;
import java.awt.Color;
import java.awt.Composite;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Insets;
import java.awt.RenderingHints;
import java.awt.image.ImageObserver;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.border.Border;


public class JImageLabel extends JLabel {

	Image image;		
	ImageObserver imageObserver;

	float alpha = 1.0f;
	String text = "";
	
	int iWidth = 1;
	int iHeight = 1;

	public JImageLabel() {}

	
	JImageLabel(ImageIcon icon) {
		setImageIcon((ImageIcon)icon);
	}
	
	public void setIcon(ImageIcon icon) {		
		setImageIcon((ImageIcon)icon);
	}

	public void setImageIcon(ImageIcon icon) {

		image = icon.getImage();		
		imageObserver = icon.getImageObserver();	

		repaint();
	}
	
	public void setImageWidth(int width) {		
		this.iWidth = width;
	}
	
	public void setImageHeight(int height) {		
		this.iHeight = height;
	}
	
	
	public void setText(String text) {
		this.text = text;
	}

	public void setAlpha(float alpha) {
		this.alpha = alpha;
		repaint();
	}

	boolean drawLink = false;

	public void drawLink(boolean state) {

		drawLink = state;	
	}
	

	int[][] linkArrowPixelMatrixColors4x5 = new int[][] {  { 0xe3e3e3,0x666769,0x212224,0x212224},{ 0xafb0b0,0x666769,0x3d3d41,0x212224},{ 0xffffff,0x545456,0xabacac,0x666769},{ 0xe3e3e3,0x212224,0xffffff,0xdcdcdc},{ 0xcecece,0xffffff,0xadadad,0xa6a6a6}};

	public void paint( Graphics g ) {
		
		super.paint(g); // * Das muss hier stehen, damit in der Tabelle hinter dem Icon die Hintergrundfarben angezeigt werden! *
		
		Graphics2D g2 = (Graphics2D) g;
		AlphaComposite newComposite =  AlphaComposite.getInstance(AlphaComposite.SRC_OVER, alpha);
		g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,  RenderingHints.VALUE_ANTIALIAS_ON);
		g2.setComposite(newComposite);

		//System.out.println(getWidth() + " " + getHeight() + " " + image.getWidth(imageObserver)+" "+ image.getHeight(imageObserver));
		
		
		int x 		= 0;
		int y 		= 0;
		int width 	= iWidth;
		int height 	= iHeight;
		
		
					
		
		Border b = getBorder();
		Insets inset = null;
		
		try {
			inset = b.getBorderInsets(this);	
		}
		catch(Exception e) {			
			 inset = new Insets(0, 0, 0, 0);
		}
		
				
		if(image != null) {
			
			x = inset.left;
			y = inset.top + getHeight()/2-height/2;

			g2.drawImage(image,  x , y, width , height , imageObserver);		
		}
		
		g2.setColor(Color.RED);
		if(drawLink) {
			
			x = inset.left + 1;
			y = inset.top + getHeight()/2-height/2;
						
			for(int iy=0;iy<4;iy++) {
				for(int ix=0;ix<4;ix++) {
					g2.setColor(new Color(linkArrowPixelMatrixColors4x5[iy][ix]));
					g2.drawLine(x+ix, y+iy, x+ix, y+iy);
				}
			}
		}
				
		FontMetrics fm = g2.getFontMetrics();
		
		g2.setColor(this.getForeground());
		g2.setFont(getFont());		
		g2.drawString(text, inset.left + width + 6 , y + inset.top + fm.getAscent() );		
		

	}		
}