package ffilechooser;



import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.InputStream;
import java.util.Vector;
import java.util.prefs.Preferences;

import javax.imageio.ImageIO;
import javax.swing.BorderFactory;
import javax.swing.DefaultListCellRenderer;
import javax.swing.DefaultListModel;
import javax.swing.DropMode;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.border.Border;
import javax.swing.border.EmptyBorder;
import javax.swing.plaf.basic.BasicScrollBarUI;
import javax.swing.text.View;



public class LeftPanel extends JPanel {



	final static JFileChooser fc = new JFileChooser(); // *  fuer Icons *

	static Preferences prefs = Preferences.userNodeForPackage(LeftPanel.class);
	static String PREF_NAME_drives_list 	= "drives_panel_driveslist";



	private DefaultListModel fileList = new DefaultListModel();
	private DrivesAndLinksCellRenderer renderer;

	JScrollPane shortCutsJListScrollPane;
	JList jList;

	private EmptyBorder devicesMargin;
	private EmptyBorder emptyMargin;
	private EmptyBorder favoritesMargin;
	

	BufferedImage emptyImage			= null;
	BufferedImage scrollbarImage		= null;
	BufferedImage dirImage 			= null;
	BufferedImage fileImage 			= null;
	BufferedImage appImage 			= null;

	JButton emptyButton;

	ImageIcon emptyImageIcon;
	ImageIcon dirImageIcon;
	ImageIcon appImageIcon;
	ImageIcon fileImageIcon;

	Color backGroundColor = new Color(0xeef1ed);
	Color backGroundColorSelected = new Color(0xd2dbd7);

	



	// * Wenn man unterhalbt des lestzten JList Elements klickt, dann wird trotzde, das letzte ELement ausgewaehlt *
	// * mit "lastSelectedIndex" den letzten selektierten Index wieder herstellen *
	int lastSelectedIndex = 0; 

	Directory directory;

	public LeftPanel(final Directory directory) {

		this.directory = directory;

		setLayout(new BorderLayout()); // * Damit passt sich das ScrollPanel automatisch der Groesse des Parent JPanels an! * 



		try	{ InputStream in = ClassLoader.class.getResourceAsStream("/ffileshooser_pack/empty.png"); emptyImage = ImageIO.read(in);}
		catch( Exception e ) {e.printStackTrace();}

		try	{ InputStream in = ClassLoader.class.getResourceAsStream("/ffileshooser_pack/scrollbar.png"); scrollbarImage = ImageIO.read(in);}
		catch( Exception e ) {e.printStackTrace();}

		try	{ InputStream in = ClassLoader.class.getResourceAsStream("/ffileshooser_pack/dir.png"); dirImage = ImageIO.read(in);}
		catch( Exception e ) {e.printStackTrace();}

		try	{ InputStream in = ClassLoader.class.getResourceAsStream("/ffileshooser_pack/file.png"); fileImage = ImageIO.read(in);}
		catch( Exception e ) {e.printStackTrace();}

		try	{ InputStream in = ClassLoader.class.getResourceAsStream("/ffileshooser_pack/app.png"); appImage = ImageIO.read(in);}
		catch( Exception e ) {e.printStackTrace();}


		emptyImageIcon 	= new ImageIcon(emptyImage);
		dirImageIcon 	= new ImageIcon(dirImage);
		appImageIcon 	= new ImageIcon(appImage);
		fileImageIcon 	= new ImageIcon(fileImage);

		Border emptyBorder = BorderFactory.createEmptyBorder(0, 0, 0, 0);        
		emptyButton = new JButton();
		emptyButton.setBorder(emptyBorder);



		jList = new JList();

		devicesMargin 	= new EmptyBorder(-directory.fframe.monitor.convertFloatToRealHeight(0.003f), directory.fframe.monitor.convertFloatToRealWidth(0.0015f), 0, 0);
		emptyMargin 		= new EmptyBorder(0, 0, 0, 0);
		favoritesMargin 	= new EmptyBorder(-directory.fframe.monitor.convertFloatToRealHeight(0.001f), directory.fframe.monitor.convertFloatToRealWidth(0.0015f), 0, 0);


		renderer = new DrivesAndLinksCellRenderer();




		// * Real Devices *
		String devicesList  ="Devices;";
		File[] tempDrivesfiles = new File("/Volumes").listFiles();
		for(int i = 0; i < tempDrivesfiles.length ; i++) {
			if(tempDrivesfiles[i].getName().startsWith(".") == false) devicesList += tempDrivesfiles[i] + ";";	
		}
		devicesList +="Favorites;";


		for(int i = 0; i < directory.favorites.length; i++) devicesList += directory.favorites[i] + ";";	


		// * Load Devices Preferences Devices *
		String[] devicesListSplit = devicesList.split(";");
		for(int i=0;i<devicesListSplit.length;i++) fileList.addElement(new File(devicesListSplit[i]));


		
		jList.setModel(fileList);
		jList.setDragEnabled(false);
		jList.setCellRenderer(renderer);
		jList.setDropMode(DropMode.INSERT);
		jList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		jList.setBackground(backGroundColor);
		jList.setFixedCellWidth(directory.drivesPanelCellWidth);
		jList.setFixedCellHeight(directory.drivesPanelCellHeight);
		jList.addMouseListener( new MouseListener() {
			public void mouseClicked(MouseEvent e) {	}

			@Override
			public void mousePressed(MouseEvent e) {		

			}

			@Override
			public void mouseReleased(MouseEvent e) {

				if(e.getButton() != 1) return;

				// * Verhindern, dass wenn eine Mouse-Click unterhalb des letzten JList Index ausgeloesst wird, der letzte Index selektiert wird *
				// * Denn das fuehrt zum Wechsel des Verzeichnisses, obwohl kein Index angeklickt wurde *


				if(jList.getMousePosition() != null && jList.getMousePosition().y > directory.drivesPanelCellHeight*(jList.getLastVisibleIndex()+1)) {

					jList.setSelectedIndex(lastSelectedIndex);						
					return;
				}

				lastSelectedIndex = jList.getSelectedIndex();



				// * Name == Leer Check fuer "Devices" und "Favorites" *
				File selectedItem = (File) jList.getSelectedValue();


				if((selectedItem.exists() == false && (selectedItem.getAbsolutePath().contains("Devices")) || (selectedItem.exists() == false && selectedItem.getAbsolutePath().contains("Favorites")))) { /* nichts tun */ }
				else {

					// * Load Directory *
					if(selectedItem.getName().compareTo("") != 0) {


						// * Waehrend dem Laden evtl. den Warte-Ball anzeigen *

						directory.animateWaitCursor();	
						directory.loadDirectory(selectedItem.getAbsolutePath()+ "/".replace("//","/"), true);
						directory.waitMode = false;
						directory.setCursor( Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
					}
				}
			}

			@Override
			public void mouseEntered(MouseEvent e) {	}

			@Override
			public void mouseExited(MouseEvent e) {	}
		});


		jList.addMouseMotionListener(new MouseMotionListener() {

			@Override
			public void mouseDragged(MouseEvent e) {

			}

			@Override
			public void mouseMoved(MouseEvent e) {				
			}	
		});


		shortCutsJListScrollPane = new JScrollPane(jList);
		shortCutsJListScrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		shortCutsJListScrollPane.getVerticalScrollBar().setBackground(Color.RED);
		shortCutsJListScrollPane.getVerticalScrollBar().setOpaque(true);
		shortCutsJListScrollPane.getVerticalScrollBar().setPreferredSize(new Dimension(8,1000));
		shortCutsJListScrollPane.setBackground(backGroundColor);
		shortCutsJListScrollPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 2, 3));
		shortCutsJListScrollPane.getHorizontalScrollBar().setBackground(Color.RED);
		shortCutsJListScrollPane.getVerticalScrollBar().setUI(new BasicScrollBarUI(){

			@Override
			protected JButton createDecreaseButton(int orientation) {
				return emptyButton;
			}

			@Override
			protected JButton createIncreaseButton(int orientation) {
				return emptyButton;
			}

			@Override
			protected void	paintDecreaseHighlight(Graphics g) {
			}
			protected void	paintIncreaseHighlight(Graphics g) {
			}

			@Override
			protected void paintThumb(Graphics g, JComponent c, Rectangle thumbBounds) {        

				g.translate(thumbBounds.x, thumbBounds.y);
				g.drawRect( 0, 0, thumbBounds.width - 2, thumbBounds.height - 1 );
				AffineTransform transform = AffineTransform.getScaleInstance((double)thumbBounds.width/scrollbarImage.getWidth(null),(double)thumbBounds.height/scrollbarImage.getHeight(null));
				((Graphics2D)g).drawImage(scrollbarImage, transform, null);
				g.translate( -thumbBounds.x, -thumbBounds.y );
			}

			@Override
			protected void paintTrack(Graphics g, JComponent c, Rectangle trackBounds) {        

				g.setColor(backGroundColor);
				g.fillRect(0, 0, c.getWidth(), c.getHeight());
			}			
		});
		add(shortCutsJListScrollPane);


		setBackground(backGroundColor);		

		updateVolumeDevices(); // von den Preferences geladenen Volumes pruefen


	}


	public void highlightListItemFromPath(String directoryPath) {

		if(directoryPath == null) return;

		if(directoryPath.compareTo("/Volumes/") == 0) {

			jList.clearSelection();
			return;
		}


		try {
			File dir = new File(directoryPath);

			while(dir.getParent() != null) {

				for(int i=0;i<fileList.size();i++) {

					if((((File)fileList.get(i)).getAbsolutePath()).compareTo(dir.getAbsolutePath()) == 0) {

						jList.setSelectedIndex(i);
						lastSelectedIndex = i;
						invalidate();

						return;
					}
				}	

				dir = dir.getParentFile();
			}
		}
		catch(Exception e) {e.printStackTrace();}
	}



	int oldVolumesCount = 0;

	public void updateVolumeDevices() {

		// * Wenn neues Laufwerk dazu gekommen ist, oder entfernt wurde, dann die Devices-Liste updaten *

		try {


			// * Real Devices holen *
			File[] realDrivesfilesTemp = new File("/Volumes").listFiles();

			Vector<File> realDrivesfiles = new Vector<File>();
			for(int i=0;i<realDrivesfilesTemp.length;i++) realDrivesfiles.add(realDrivesfilesTemp[i]);


			// * Preference Devices *
			Vector<File> prefDeviceFiles 	= getDevicesFromList(); 
			int devicesStartIndex 			= getDevicesStartIndex();


			// * Pruefen ob ein Real Device in der Prefs Liste nicht vorhanden, wenn dann hinzufuegen *

			Vector<File> filesToAdd = new Vector<File>();
			for(int i=0;i<realDrivesfiles.size();i++) {

				// * Wenn kein Volume... dann ignorieren *
				if(realDrivesfiles.elementAt(i).getName().toLowerCase().startsWith(".")) continue; 


				// * Pruefen ob Real Volumen Name in der Pref Volume Liste ... *
				boolean gefunden = false;
				for(int ii=0;ii<prefDeviceFiles.size();ii++) {

					if(prefDeviceFiles.elementAt(ii).getAbsolutePath().compareTo(realDrivesfiles.elementAt(i).getAbsolutePath()) == 0) {

						gefunden = true;
						break;
					}
				}

				if(gefunden == false) {

					// * Wenn Real Volume nicht in der Pref Device Liste, dann hinzufuegen *
					filesToAdd.add(realDrivesfiles.elementAt(i));
				}					
			}



			// * Pruefen ob ein Prefs Device nicht in der Real Liste vorhanden, wenn dann loeschen *

			Vector<File> filesToRemove = new Vector<File>();
			for(int i=0;i<prefDeviceFiles.size();i++) {

				// * Wenn kein Volume... dann ignorieren *
				if(prefDeviceFiles.elementAt(i).getName().toLowerCase().startsWith(".") || prefDeviceFiles.elementAt(i).getName().toLowerCase().startsWith("devices")) continue; 


				// * Pruefen ob Prefs Volumen Name in der Real Volume Liste ... *
				boolean gefunden = false;
				for(int ii=0;ii<realDrivesfiles.size();ii++) {

					if(realDrivesfiles.elementAt(ii).getAbsolutePath().compareTo(prefDeviceFiles.elementAt(i).getAbsolutePath()) == 0) {

						gefunden = true;
						break;
					}
				}


				if(gefunden == false) {

					// * Wenn Real Volume nicht in der Pref Device Liste, dann hinzufuegen *
					filesToRemove.add(prefDeviceFiles.elementAt(i));
				}					
			}


			// *  gefundene Volumes in die fileList aufnehmen *

			int addIndex = devicesStartIndex+prefDeviceFiles.size();
			for(int i=0;i<filesToAdd.size();i++) {					
				fileList.add(addIndex+i,filesToAdd.elementAt(i));			
			}

			// *  nicht gefundene Volumes aus der fileList loeschen *

			for(int i=0;i<filesToRemove.size();i++) {					
				fileList.removeElement(filesToRemove.elementAt(i));			
			}

		}
		catch(Exception e) { e.printStackTrace();}
	}



	private Vector<File> getDevicesFromList() {

		Vector<File> deviceFiles = new Vector<File>(); 

		int devicesStartIndex 	= getDevicesStartIndex();
		int favoritesStartIndex 	= getFavoritesStartIndex();

		if(devicesStartIndex < favoritesStartIndex) {
			for(int i=devicesStartIndex;i<favoritesStartIndex;i++) deviceFiles.add((File)fileList.get(i));			
		}
		else {
			for(int i=devicesStartIndex;i<fileList.size();i++) deviceFiles.add((File)fileList.get(i));		
		}		
		return deviceFiles;
	}

	private Vector<File> getFavoritesFromList() {

		Vector<File> favoritesFiles = new Vector<File>(); 

		int devicesStartIndex 	= getDevicesStartIndex();
		int favoritesStartIndex 	= getFavoritesStartIndex();

		if(favoritesStartIndex < devicesStartIndex) {
			for(int i=favoritesStartIndex;i<devicesStartIndex;i++) favoritesFiles.add((File)fileList.get(i));			
		}
		else {
			for(int i=favoritesStartIndex;i<fileList.size();i++) favoritesFiles.add((File)fileList.get(i));	
		}		
		return favoritesFiles;
	}


	private int getDevicesStartIndex() {

		for(int i = 0; i < fileList.size() ; i++) {
			if(((File)fileList.get(i)).exists() == false && ((File)fileList.get(i)).getAbsolutePath().contains("Devices")) return i;	
		}			
		return -1;
	}

	private int getFavoritesStartIndex() {

		for(int i = 0; i < fileList.size() ; i++) {
			if(((File)fileList.get(i)).exists() == false && ((File)fileList.get(i)).getAbsolutePath().contains("Favorites")) return i;	
		}			
		return -1;
	}




	class DrivesAndLinksCellRenderer extends DefaultListCellRenderer {

		private static final long serialVersionUID = -7799441088157759804L;

		private JImageLabel jImage = new JImageLabel();

		private Color textSelectionColor 		= new Color(0x222222);
		private Color textNonSelectionColor 		= new Color(0x222222);

		private Color backgroundSelectionColor 		= backGroundColorSelected;
		private Color backgroundNonSelectionColor 	= backGroundColor;



		@Override
		public Component getListCellRendererComponent(JList list, Object value, int index, boolean selected,	boolean expanded) {


			jImage.setOpaque(true);

			jImage.setPreferredSize(new Dimension(directory.drivesPanelCellWidth, directory.drivesPanelCellHeight));

			try {

				if(((File)value).exists() == false && ((File)value).getAbsolutePath().contains("Devices")) {

					jImage.setBackground(backgroundNonSelectionColor);
					jImage.setIcon(emptyImageIcon);
					jImage.setImageHeight(1);
					jImage.setImageWidth(1);
					jImage.setText("Devices");
					jImage.setFont(directory.drivesPanelCategoryFontBold);
					jImage.setForeground(new Color(0x555555));			
					jImage.setBorder(devicesMargin);				
					return jImage;
				}

				if(((File)value) == null) {

					jImage.setBackground(backgroundNonSelectionColor);
					jImage.setIcon(emptyImageIcon);
					jImage.setImageHeight(1);
					jImage.setImageWidth(1);
					jImage.setText("");
					jImage.setFont(directory.drivesPanelCategoryFontBold);
					jImage.setBorder(emptyMargin);				
					return jImage;
				}

				if(((File)value).exists() == false && ((File)value).getAbsolutePath().contains("Favorites")) {

					jImage.setBackground(backgroundNonSelectionColor);
					jImage.setIcon(emptyImageIcon);
					jImage.setImageHeight(1);
					jImage.setImageWidth(1);
					jImage.setText("Favorites");
					jImage.setFont(directory.drivesPanelCategoryFontBold);
					jImage.setForeground(new Color(0x555555));					
					jImage.setBorder(favoritesMargin);

					//jImage.setVerticalAlignment(JLabel.BOTTOM);
					//jImage.setVerticalTextPosition(JLabel.BOTTOM);
					//setAlignmentY(BOTTOM_ALIGNMENT);

					jImage.setPreferredSize(new Dimension(directory.drivesPanelCellWidth, (int)(directory.drivesPanelCellHeight*1.4f)));

					return jImage;
				}


				Border margin = new EmptyBorder(0, directory.fframe.monitor.convertFloatToRealWidth(0.006f), 0, 0); // * Text vom linken Rand entfernt *
				jImage.setBorder(margin);			
				jImage.setImageHeight((int)((float)directory.drivesPanelCellHeight*directory.drivesPanelImageMultip));
				jImage.setImageWidth((int)((float)directory.drivesPanelCellHeight*directory.drivesPanelImageMultip));

				File file = (File)value;

				try {

					if(file.getName().compareTo("") != 0) 	jImage.setIcon(Functions.iconToImageIcon(fc.getUI().getFileView(fc).getIcon(file)));
					else 									jImage.setIcon(emptyImageIcon);
				}
				catch(Exception e) {		

					e.printStackTrace();

					if(file.isDirectory() && file.getName().contains(".app") == false) 	jImage.setIcon(dirImageIcon);
					else if(file.isFile() || file.getName().contains(".app") == true) {

						if(file.getName().contains(".app") == true) 	jImage.setIcon(appImageIcon);
						else if(file.isFile()) 						jImage.setIcon(fileImageIcon);
					}			

					if(file.getName().compareTo("") != 0) 	jImage.setIcon(fileImageIcon);
					else 									jImage.setIcon(emptyImageIcon);
				}

				jImage.setFont(directory.drivesPanelFont);
				jImage.setText(file.getName());

				if (selected) {

					jImage.setFont(directory.drivesPanelFontBold);
					jImage.setBackground(backgroundSelectionColor);
					jImage.setForeground(textSelectionColor);
				} 
				else {

					jImage.setFont(directory.drivesPanelFont);
					jImage.setBackground(backgroundNonSelectionColor);
					jImage.setForeground(textNonSelectionColor);
				}

			}
			catch(Exception e) {		

			}

			return jImage;
		}
	}
}

